/*
Copyright J.S. 2023, license HYKKEOHL1 (free software, permissive)

NOTE: the pace of work has been emphasized over the quality while writing this, animation engine has some bugs

compiling in UNIX:
i586-pc-msdosdjgpp-g++ filename.cpp -lmidasall -lalleg -o FILENAME.EXE

The EXE file needs to be modified with DJGPP's stubedit before running, if you keep on using HLT instruction to save CPU cycles:
stubedit FILENAME.EXE dpmi=CWSDPR0.EXE

*/

#include <stdio.h>
#include <string.h>
#include <dos.h>
#include <iostream> 
#include <fstream>
#include <cmath>
#include <vector>
#include <sys/nearptr.h>
#include <crt0.h>
#include <time.h>

#include <stdlib.h>
#include <conio.h>
#include "include/midasdll.h"

using namespace std;

const int RUUDUNLEVEYS = 320;
const int RUUDUNKORKEUS = 200;
const int RUUDUNTAVULEVEYS = 80; //joka kuvarivi on 80 tavua (320 pikseliä, 4 per tavu)

int tarinanvaihe = 3;
bool tkesk = true;
int t_ajastin = 0;
bool taustakuva = false;
bool lopetus = false;
bool erikoisefekti = false;
bool erikoisefekti2 = false;
void (*efektiptr)(int ekount);
void (*efektiptr2)(int ekount);
int efektikountteri;
MIDASsample *aaniloop_sample;
int aaniloop_kesto;
int aaniloop_kerrat;
int aaniloop_kountteri;
int *piipptr;
long long tickCount = 0;

MIDASsample auto_s;
MIDASsample ovi1_s;
MIDASsample ovi2_s;
MIDASsample radio_s;
MIDASsample mendel_s;
MIDASsample tvkohina_s;
MIDASsample propuhe1_s;
MIDASsample paapuhe1_s;
MIDASsample propuhe2_s;
MIDASsample paapuhe2_s;
MIDASsample ankpuhe1_s;
MIDASsample ankpuhe2_s;
MIDASsample liuovi_s;
MIDASsample kaup_s;
MIDASsample kaytava_s;
MIDASsample hissi_s;
MIDASsample hisovi_s;
MIDASsample erovi_s;
MIDASsample czteksti_s;
MIDASsample cz_s;
MIDASsample bzz_s;
MIDASsample laser_s;
MIDASsample lintu1_s;
MIDASsample lintu2_s;
MIDASsample lintu3_s;
MIDASsample lyhyt_s;
MIDASsample pitka_s;
MIDASsample lintu4_s;
MIDASsample lintu5_s;
MIDASsample kaatuu_s;
MIDASsample g_aani_s;
MIDASsample error_s;
MIDASsample uli1_s;
MIDASsample g_aani2_s;
MIDASsample uli2_s;
MIDASsample syspiip_s;

unsigned char *cga_osoite = (unsigned char*)(0xB800 * 16 + __djgpp_conventional_base);

//virtuaalinen framebufferi
unsigned char vfb[16000];  //4 pikseliä per tavu, 320*200/4 = 16 000

struct nelio {
  short int x = 0;
  short int y = 0;
  short int leveys = 0;
  short int korkeus = 0;
};

struct bmkuva {
  short int leveys;
  short int tavuleveys;
  short int leveysjaannos;
  short int korkeus;
  unsigned char *bittikartta;
};

struct esinetoiminta {
  int x_muutos = 0;
  int y_muutos = 0;
  int x_abs = 999;
  int y_abs = 999;
  int ruudulla = 99;
  bool sammuta = false;
};

class esineluokka {
public:
  int x;
  int y;
  int suunta;
  int vauhti;  //-99 on liiku joka framella, muuten ilmeisesti pienempi on suurempi vauhti
  int turbo;
  int vkountteri;
  int ruudulla;
  bmkuva *kuva;
  bool lapinak;
  bool kaksivarinen;
  int toimintakountteri;
  int toimintakatto;
  bool toiminta;
  bool rajattu;
  nelio rajausnelio;
  esinetoiminta (*toimintaptr)(int tkount);
  esineluokka();
  void esinepiirto();
  void poista_bittikartta();
};

struct kavelyohje {
  int x_paamaara = 0; //päämääristä vain jompi kumpi on käytössä
  int y_paamaara = 0;
  int paasuunta = 0; //1-4, 6-9
  int sivusuunta = 0; //samat, mutta vain pääilmansuunnat
  int suuntapoikkeama = 0; //kuinka usein sivusuuntaan mennään
  int suuntakountteri = 0;
  bool loppuun_kesk = false;
  pair<int, int> flippaa = (make_pair(2, 0)); //Ensimmäinen arvo: 2 = ei muutosta, 0 = flip pois, 1 = flip päälle. Jälkimmäinen arvo on x:n muutos, mikä tapahtuu flippauksessa.
  int alkuframe = 999; //arvo 999 = ei käytössä
  int loppuframe = 999; //arvo 999 = ei käytössä
  int kliikemuutos = 999; //arvo 999 = ei käytössä, uusi kliikenopeusarvo
};

class hahmoluokka {
private:
  bool flipattu;
  void flippaus();
public:
  int x;
  int y;
  bmkuva *kuva;
  int ruudulla;
  bool lapinak;
  int arkki_w;
  int arkki_h;
  bool kaksivarinen;
  bool kavelee;
  vector<kavelyohje> kavelyvec;
  int kframet[8]; //kaksi ensimmäistä indeksiä ovat ylöskävely-framejen alkukohta (zero-based) ja määrä (one-based), sitten vastaavasti alaskävely, vasemmalle kävely ja oikealle kävely. kävelyframeja on siis maksimissaan neljään suuntaan, niiden lukumäärää ei ole rajoitettu ja eri suuntaan voi olla eri määriä. mutta samaan suuntaan menevien kävelyframejen on oltava perättäisiä numeroita ja oikeassa järjestyksessä.
  int kliikenopeus; //varsinainen kävelynopeus. arvo joka plussataan, kunnes sata ylittyy, jolloin liikutaan niin monta pikseliä, mitä on sadasta yli ja loput jää kountteriin
  int kframenopeus; //kavelyfkountin maksimiarvo, jonka ylittyessä frame vaihtuu
  int kavelylkount; //liikekountteri kävelyyn
  int kavelyfkount; //framekountteri kävelyyn
  int suunta;
  int vauhti;
  int vkountteri;
  int frame;  //0-based
  vector<int> framekierto; //arvo 99 = tauko ja seuraavassa elementissä tauon pituus. yli 100 = soitetaan ääniefekti, johon pointteri on framekierto_sample
  MIDASsample *framekierto_sample;
  int fk_kountteri;
  int fk_tauko;  //sisältö tulee vain piirtoloopin toiminnasta, ei aseteta muuten
  int framehidastus; //pitää olla nolla, jos pois päältä
  int fh_kountteri;  //myös tämä pitää olla nolla, jos framehidastus on pois päältä
  int toimintakountteri;
  int toimintakatto;
  bool toiminta;
  int toim_arg;
  esinetoiminta (*toimintaptr)(int tkount, int toim_arg);
  hahmoluokka();
  void hahmopiirto();
  void seuraava_kframe();
  void poista_bittikartta();
  void aseta_flip(bool asetus);
};

vector<esineluokka*> esinevec;
vector<hahmoluokka*> hahmovec;

void MIDAS_CALL TimerCallback() {
  tickCount++;
}

MIDASmodule teema;
MIDASmodule baarimusa;
MIDASmodule ambu;
MIDASmodule parcf;
MIDASmodule ranta;
MIDASmodule perif;
MIDASmodule instf;
MIDASmodule seko;
MIDASmodulePlayHandle teema_h = 0;
MIDASmodulePlayHandle baarimusa_h = 0;
MIDASmodulePlayHandle ambu_h = 0;
MIDASmodulePlayHandle parcf_h = 0;
MIDASmodulePlayHandle ranta_h = 0;
MIDASmodulePlayHandle perif_h = 0;
MIDASmodulePlayHandle instf_h = 0;
MIDASmodulePlayHandle seko_h = 0;

void soita_musa(MIDASmodule *musa, MIDASmodulePlayHandle *musa_h) {
  MIDAScloseChannels();
  *musa_h = MIDASplayModule(*musa, true);
  MIDASsetTimerCallbacks(70000, FALSE, &TimerCallback, NULL, NULL );
  MIDASstartBackgroundPlay( 0 );
}

void lopeta_musa(MIDASmodulePlayHandle musa_h) {
  MIDASstopModule(musa_h);
  MIDASstopBackgroundPlay();
  MIDASopenChannels(5);
}

bmkuva *taustakuva_ptr;
bmkuva maisema_bm;
bmkuva huone_bm;
bmkuva kotitalo_bm;
bmkuva metsikko_bm;
bmkuva masto_bm;
bmkuva kaupunki1_bm;
bmkuva kaupunki2_bm;
bmkuva kaupunki3_bm;
bmkuva puisto_bm;
bmkuva puisto2_bm;
bmkuva ranta_bm;
bmkuva peri1_bm;
bmkuva peri2_bm;
bmkuva peri3_bm;
bmkuva perig_bm;
bmkuva baari_bm;
bmkuva insttalo_bm;
bmkuva instkylt_bm;
bmkuva kaytava_bm;
bmkuva hissi_bm;
bmkuva ylakerta_bm;
bmkuva cz_bm;
bmkuva tuolipaa_bm;
bmkuva aivot_bm;
bmkuva aivobzz_bm;
bmkuva aivobzz2_bm;
bmkuva aivobzz3_bm;
bmkuva droidi_bm;
bmkuva auto1_bm;
bmkuva protais_bm;
bmkuva prota4_bm;
bmkuva pilvi1_bm;
bmkuva pilvi2_bm;
bmkuva pilvi3_bm;
bmkuva profis_bm;
bmkuva paaylos_bm;
bmkuva paauli_bm;
bmkuva kasi1_bm;
bmkuva kasi2_bm;
bmkuva kasi3_bm;
bmkuva ilme_bm;
bmkuva ovi1_bm;
bmkuva ovi2_bm;
bmkuva hiseina_bm;
bmkuva hikansi_bm;
bmkuva hilat_bm;
bmkuva liplap_bm;
bmkuva aalto_bm;
bmkuva lintu1_bm;
bmkuva lintu2_bm;
bmkuva plintu_bm;
bmkuva keinu_bm;
bmkuva drone_bm;
bmkuva nokka_bm;
bmkuva kasvi1_bm;
bmkuva prota1_bm;
bmkuva prota2_bm;
bmkuva prota3_bm;
bmkuva prof_bm;
bmkuva avustaja_bm;
bmkuva kulkija1_bm;
bmkuva kulkija2_bm;
bmkuva kulkija3_bm;
bmkuva kulkija4_bm;
bmkuva kulkija5_bm;
bmkuva kulkija6_bm;
bmkuva koira_bm;
bmkuva ambuh_bm;
bmkuva liovi_bm;
bmkuva hisovi_bm;
bmkuva thovi_bm;
bmkuva tvmies_bm;
bmkuva alkuteks_bm;
bmkuva lopputeks_bm;
bmkuva eof_bm;
bmkuva morteks_bm;
bmkuva maisteks_bm;
bmkuva aveteks_bm;
bmkuva teksvill_bm;
bmkuva textparc_bm;
bmkuva textperi_bm;
bmkuva texdrama_bm;
bmkuva czteksti_bm;
bmkuva textmitt_bm;
bmkuva fehler_bm;
bmkuva ambu_bm;
bmkuva ambu2_bm;
bmkuva ambu3_bm;
bmkuva ambu4_bm;
bmkuva amovi_bm;
bmkuva defai_bm;
bmkuva glogo_bm;
bmkuva puuosa_bm;
bmkuva puita_bm;
bmkuva juna_bm;
bmkuva cz_poyta_bm;
bmkuva bovi1_bm;
bmkuva bovi2_bm;
bmkuva potkula_bm;
bmkuva pluga_bm;
bmkuva plugb_bm;
bmkuva plugc_bm;
bmkuva osa_bm;
bmkuva isolintu_bm;
bmkuva error_bm;
bmkuva eeg_bm;
bmkuva eegpeite_bm;
bmkuva eegtaulu_bm;
bmkuva ascii1_bm;
bmkuva ascii2_bm;
bmkuva ascii3_bm;
bmkuva ascii4_bm;
bmkuva pommit_bm;
bmkuva kaatuu_bm;
bmkuva autotie_bm;
bmkuva sydan_bm;
bmkuva mittari_bm;

esineluokka alkuteks;
esineluokka lopputeks;
esineluokka morteks;
esineluokka maisteks;
esineluokka teksvill;
esineluokka textparc;
esineluokka textperi;
esineluokka czteksti;
esineluokka error;
esineluokka eeg;
esineluokka eegpeite;
esineluokka eegtaulu;
esineluokka glogo;
esineluokka auto1;
esineluokka ambu2;
esineluokka amovi;
esineluokka paaylos;
esineluokka kasi1;
esineluokka kasi2;
esineluokka kasi3;
esineluokka ilme;
esineluokka protais;
esineluokka prota4;
esineluokka hiseina;
esineluokka hikansi;
esineluokka hilat;
esineluokka pilvi1;
esineluokka pilvi2;
esineluokka pilvi3;
esineluokka ovi1;
esineluokka ovi2;
esineluokka profis;
esineluokka aalto;
esineluokka liplap;
esineluokka tvmies;
esineluokka puuosa;
esineluokka puita;
esineluokka juna;
esineluokka cz_poyta;
esineluokka bovi1;
esineluokka bovi2;
esineluokka potkula;
esineluokka pluga;
esineluokka plugb;
esineluokka plugc;
esineluokka osa;
esineluokka lintu2;
esineluokka ascii1;
esineluokka ascii2;
esineluokka ascii3;
esineluokka ascii4;

hahmoluokka lintu1;
hahmoluokka plintu;
hahmoluokka keinu;
hahmoluokka drone;
hahmoluokka nokka;
hahmoluokka kasvi1;
hahmoluokka kasvi2;
hahmoluokka droidi;
hahmoluokka prota1;
hahmoluokka prota2;
hahmoluokka prota3;
hahmoluokka prof;
hahmoluokka avustaja;
hahmoluokka kulkija1;
hahmoluokka kulkija2;
hahmoluokka kulkija3;
hahmoluokka kulkija4;
hahmoluokka kulkija5;
hahmoluokka kulkija6;
hahmoluokka koira;
hahmoluokka ambuh;
hahmoluokka liovi;
hahmoluokka hisovi;
hahmoluokka thovi;
hahmoluokka aivobzz;
hahmoluokka ambu3;
hahmoluokka ambu4;

esineluokka::esineluokka():
  x(0), y(0), suunta(0), vauhti(0), turbo(0), kuva(NULL), vkountteri(0), ruudulla(0), toimintakountteri(0), toiminta(false), toimintakatto(0), toimintaptr(NULL), kaksivarinen(false), lapinak(true), rajattu(false) {
  esinevec.push_back(this);
}

hahmoluokka::hahmoluokka():
  flipattu(false), x(0), y(0), kavelee(false), suunta(0), kuva(NULL), vkountteri(0), ruudulla(0), vauhti(0), frame(0), lapinak(true), kaksivarinen(false), fk_kountteri(0), fk_tauko(0), framehidastus(0), fh_kountteri(0), toimintaptr(NULL), toim_arg(0), toiminta(false), toimintakatto(0), toimintakountteri(0), kliikenopeus(130), kframenopeus(3)
 {
  hahmovec.push_back(this);
}

bmkuva avaa_kuva(bmkuva bm, string tiedostonimi) {

  cout << "Avataan kuvaa: " << tiedostonimi;
  ifstream filevar(tiedostonimi, ios::binary | ios::in);
  vector<char> bytes((istreambuf_iterator<char>(filevar)), (istreambuf_iterator<char>()));
  filevar.close();
  cout << " ...OK" << endl;

  char temp_array[4];
  int wh_counter = 0;
  for(vector<char>::iterator wh_iter = bytes.begin(); wh_iter != bytes.begin()+4; ++wh_iter) {
    temp_array[wh_counter] = *wh_iter;
    wh_counter++;
  }

  memcpy(&bm.leveys, &temp_array, 2);
  memcpy(&bm.korkeus, &temp_array[2], 2);

  if(bm.leveys % 4 == 0) {
    bm.tavuleveys = bm.leveys/4;
    bm.leveysjaannos = 0;
  }
  else {
    bm.tavuleveys = bm.leveys/4+1;
    bm.leveysjaannos = bm.leveys%4;
  }

  bm.bittikartta = new unsigned char[bm.leveys/4*bm.korkeus];
 
  int bitcounter = 7;
  int bytecounter = 0;
  unsigned char writebit = 0;
  for(int i = 0; i != bm.leveys/4*bm.korkeus; i++) bm.bittikartta[i] = 0;

  for(vector<char>::iterator biter = bytes.begin()+4; biter != bytes.end(); ++biter) {

    unsigned char tempbyte = *biter;
    int adjacents = tempbyte & ~(1 << 7);

    if((tempbyte >> 7) & (1 == 1)) {
      writebit = 1;
    }
    else writebit = 0;
    while(adjacents > 0) {

      if(bitcounter % 2 == 0) cerr << "zerobit misalignment: " << bitcounter << endl;
      bm.bittikartta[bytecounter] &= ~(1 << bitcounter);
      bitcounter--;

      if(bitcounter % 2 != 0 and bitcounter != 0) cerr << "drawbit misalignment: " << bitcounter << endl;
      if(writebit) bm.bittikartta[bytecounter] |= 1 << bitcounter;
      else bm.bittikartta[bytecounter] &= ~(1 << bitcounter);

      bitcounter--;
      adjacents--;
      if(bitcounter == -1) {
	bitcounter = 7;
	bytecounter++;
	if(bytecounter == bm.leveys/4*bm.korkeus) break;
      }
    }
  }
  return bm;
}

unsigned char tavuflip(unsigned char tavu) {
  unsigned char uusitavu = 0;
  if(tavu & 64) uusitavu |= 1;
  if(tavu & 16) uusitavu |= 4;
  if(tavu & 4) uusitavu |= 16;
  if(tavu & 1) uusitavu |= 64;
  return uusitavu;
}

void hahmoluokka::flippaus() {
  flipattu ? flipattu = false : flipattu = true;
  unsigned char uusikuva[kuva->tavuleveys*kuva->korkeus];
  for(int j = 0; j != kuva->korkeus; j++) {
    for(int i = 0; i != kuva->tavuleveys; i++) {
      uusikuva[kuva->tavuleveys-1-i+j*kuva->tavuleveys] = kuva->bittikartta[i+j*kuva->tavuleveys];
    }
  }
  for(int j = 0; j != kuva->korkeus; j++) {
    for(int i = 0; i != kuva->tavuleveys; i++) {
      uusikuva[i+j*kuva->tavuleveys] = tavuflip(uusikuva[i+j*kuva->tavuleveys]);
    }
  }
  for(int i = 0; i != kuva->korkeus*kuva->tavuleveys; i++) {
    kuva->bittikartta[i] = uusikuva[i];
  }
}

void hahmoluokka::aseta_flip(bool asetus) {
  if(asetus and flipattu) return;
  if(asetus and !flipattu) { flippaus(); return; }
  if(!asetus and flipattu) { flippaus(); return; }
}

void piirraosakuva(bmkuva *kuva, int x, int y, nelio osio, bool lapinak, bool mustapiirto) {

  if((x < 0 or x > RUUDUNLEVEYS) and (x+osio.leveys < 0 or x+osio.leveys > RUUDUNLEVEYS)) {
    return;
  }

  if(x < 0) {
    if(x % 4 == -1) x -= 2;
    else if(x % 4 == -3) x += 2;
  }

  int y_lahto = y*RUUDUNTAVULEVEYS;
  int tavux = x/4;

  if((x+osio.x) % 4 == 0) {  //Ei tarvitse mennä bittitasolle, joka tavussa neljä merkitsevää bittiä
    for(int i = 0; i != osio.korkeus; i++) { //piirretään kuva rivi kerrallaan

      //Ei piirretä rivejä, jotka eivät osu näytölle
      if(y+i < 0) continue;
      if(y+i >= RUUDUNKORKEUS) break;

      //Jos kuva on osin piilossa ruudun vasemmalla puolella
      if(x < 0) {
	for(int j = 0; j != osio.leveys/4+tavux; j++) {
	  if(j == 0 or j == osio.leveys/4+tavux-1) {
	    if(y_lahto+i*RUUDUNTAVULEVEYS+j < 0 or y_lahto+i*RUUDUNTAVULEVEYS+j >= 16000) {
	      for(;;) cout << "bmkuva1: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			   << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << ", i: " << i << " & " << j
			   << ", indeksi: " << y_lahto+i*RUUDUNTAVULEVEYS+j << endl;
	    }
	  }

	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+j] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux];
	  else {
	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+j] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+j] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux];
	  }
	}
      }
      
      //Jos kuva menee ruudusta ohi oikealta
      else if((x + osio.leveys) > RUUDUNLEVEYS) {
	for(int j = 0; j != RUUDUNTAVULEVEYS-tavux; j++) { //loopataan niin monta kertaa kuin mitä kuvasta on näkyvissä
	  if(j == 0 or j == RUUDUNTAVULEVEYS-tavux-1) {
	    if( y_lahto+i*RUUDUNTAVULEVEYS+tavux+j  < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+j   >= 16000) {
	      for(;;) cout << "bmkuva2: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			   << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << endl;
	    }
	  }
	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	  else {
	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	  }
	}
      }

      //jos koko kuva näkyy ruudussa
      else {
	for(int j = 0; j != osio.leveys/4; j++) { //Riviä piirtäessä käydään läpi kuva sen tavuleveydeltä
	  if(j == 0 or j == osio.leveys/4-1) {
	    if(y_lahto+i*RUUDUNTAVULEVEYS+tavux+j < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+j >= 16000) {
	      for(;;) cout << "bmkuva3: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			   << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << ", i & j: " << i << " & " << j
			   << ", indeksi: " << y_lahto+i*RUUDUNTAVULEVEYS+tavux+j << endl;
	    }
	  }
	  
	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	  else {
	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	  }
	}
      }
    }
  }
  else {  //Jos mennään bittitasolle...
    int bittisiirto = abs(x%4*2);

    for(int i = 0; i != osio.korkeus; i++) { //piirretään kuva rivi kerrallaan
      if(y+i < 0) continue;
      if(y+i >= RUUDUNKORKEUS) break;
      
      unsigned char ylibitit1 = 0;
      unsigned char ylibitit2 = 0;

      int osiotavux = osio.x/4;
      int k = 0;

      //Jos kuva menee ruudusta yli vasemmalta
      if(x < 0) {
	while(1) {  //Rivinpiirtolooppi
	  if( y_lahto+i*RUUDUNTAVULEVEYS+k-1  < 0 or y_lahto+i*RUUDUNTAVULEVEYS+k-1 >= 16000) {
	    for(;;) cout << "bmkuva3b: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			 << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << ", i & k: " << i << " & " << k
			 << ", indeksi: " << y_lahto+i*RUUDUNTAVULEVEYS+k-1 << endl;
	  }
	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k-tavux];
	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	    }
	  }

	  k++;

	  if(k >= osio.leveys/4+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {           
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] &= ~muokattava_tavu;
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	      }
	    }
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k-tavux];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	    }
	  }
	  k++;
	  if(k >= osio.leveys/4+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] &= ~muokattava_tavu;
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	      }
	    }
	    break;
	  }
	}
      }

      //Jos kuva menee ruudusta ohi oikealta
      else if((x + osio.leveys) > RUUDUNLEVEYS) {
	while(1) {  //Rivinpiirtolooppi

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];

	  //ota ylijäämäbitit talteen ylibitit1:een
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }
	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	  else {
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	  }

	  k++;

	  if(k >= RUUDUNTAVULEVEYS-tavux) {
	    muokattava_tavu = 0;
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;
	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	  else {
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	  }
	
	  k++;
	  if(k >= RUUDUNTAVULEVEYS-tavux) {
	    muokattava_tavu = 0;
	    break;
	  }
	}
      }
      //jos koko (osa)kuva näkyy ruudussa
      else {
	while(1) {  //Rivinpiirtolooppi
	  if( y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   >= 16000) {
	    for(;;) cout << "bmkuva5: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			 << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << endl;
	  }

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];

	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	  else {
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	  }
	  
	  k++;
	  if(k >= osio.leveys/4) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];
	  
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	  else {
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	  }
	  
	  k++;
	  if(k >= osio.leveys/4) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	    break;
	  }
	}
      }
    }
  }
}

void piirraosakuva_rajattu(bmkuva *kuva, int x, int y, nelio osio, bool lapinak, bool mustapiirto, nelio piirtoalue) {

  if((x < 0 or x > RUUDUNLEVEYS) and (x+osio.leveys < 0 or x+osio.leveys > RUUDUNLEVEYS)) {
    return;
  }

  int alue_tavux = piirtoalue.x/4;
  int alue_tavuleveys = piirtoalue.leveys/4;

  if(x < 0) {
    if(x % 4 == -1) x -= 2;
    else if(x % 4 == -3) x += 2;
  }

  int y_lahto = y*RUUDUNTAVULEVEYS;
  int tavux = x/4;
  if((x+osio.x) % 4 == 0) {  //Ei tarvitse mennä bittitasolle, joka tavussa neljä merkitsevää bittiä

    for(int i = 0; i != osio.korkeus; i++) { //piirretään kuva rivi kerrallaan
      if(y+i < 0) continue; 
      if(y+i >= RUUDUNKORKEUS) break;
      if(y+i < piirtoalue.y) {
	continue;
      }
      if(y+i > piirtoalue.y+piirtoalue.korkeus) {
	break;
      }

      if(x < 0) { //kuva osin ohi vasemmalta
	for(int j = 0; j != osio.leveys/4+tavux; j++) {
	  if(j >= alue_tavux-1 and j <= alue_tavux-1+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+j+1] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux];
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+j+1] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux]
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+j+1] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j-tavux];
	    }
	  }
	}
      }
      
      //Jos kuva menee ruudusta ohi oikealta
      else if((x + osio.leveys) > RUUDUNLEVEYS) {
	for(int j = 0; j != RUUDUNTAVULEVEYS-tavux; j++) { //loopataan niin monta kertaa kuin mitä kuvasta on näkyvissä
	  if(j+tavux >= alue_tavux and j+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j]
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	    }
	  }
	}
      }

      //jos koko kuva näkyy ruudussa
      else {
	for(int j = 0; j != osio.leveys/4; j++) { //Riviä piirtäessä käydään läpi kuva sen tavuleveydeltä
	  if(j+tavux >= alue_tavux and j+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] &= ~kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j]
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osio.x/4+j];
	    }
	  }
	}
      }
    }
  }
  else {  //Jos mennään bittitasolle...
    int bittisiirto = abs(x%4*2);

    for(int i = 0; i != osio.korkeus; i++) { //piirretään kuva rivi kerrallaan

      if(y+i < 0) continue;
      if(y+i >= RUUDUNKORKEUS) break;
      if(y+i < piirtoalue.y) continue;
      if(y+i > piirtoalue.y+piirtoalue.korkeus) break;
      
      unsigned char ylibitit1 = 0;
      unsigned char ylibitit2 = 0;

      int osiotavux = osio.x/4;
      int k = 0;

      //Jos kuva menee ruudusta yli vasemmalta
      if(x < 0) {
	while(1) {  //Rivinpiirtolooppi
	  if( y_lahto+i*RUUDUNTAVULEVEYS+k-1  < 0 or y_lahto+i*RUUDUNTAVULEVEYS+k-1 >= 16000) {
	    for(;;) cout << "bmkuva3b: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			 << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << ", i & k: " << i << " & " << k
			 << ", indeksi: " << y_lahto+i*RUUDUNTAVULEVEYS+k-1 << endl;
	  }
	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k-tavux];
	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    if(k >= alue_tavux and k <= alue_tavux+alue_tavuleveys) {
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] &= ~muokattava_tavu; //k-1
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] = muokattava_tavu;
	      }
	    }
	  }
	  
	  k++;

	  if(k >= osio.leveys/4+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {
	      if(k >= alue_tavux and k <= alue_tavux+alue_tavuleveys) {
		if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] &= ~muokattava_tavu;
		else {
		  lapinak ?
		    vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] |= muokattava_tavu
		    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] = muokattava_tavu;
		}
	      }
	    }
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k-tavux];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;
	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    if(k >= alue_tavux and k <= alue_tavux+alue_tavuleveys) {
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] &= ~muokattava_tavu;
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] = muokattava_tavu;
	      }
	    }
	  }
	  k++;
	  if(k >= osio.leveys/4+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {
	      if(k >= alue_tavux and k <= alue_tavux+alue_tavuleveys) {
		if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] &= ~muokattava_tavu;
		else {
		  lapinak ?
		    vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] |= muokattava_tavu
		    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k] = muokattava_tavu;
		}
	      }
	    }
	    break;
	  }
	}
      }

      //Jos kuva menee ruudusta ohi oikealta
      else if((x + osio.leveys) > RUUDUNLEVEYS) {

	while(1) {  //Rivinpiirtolooppi

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];

	  //ota ylijäämäbitit talteen ylibitit1:een
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }
	  if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	  }

	  k++;

	  if(k >= RUUDUNTAVULEVEYS-tavux) {
	    muokattava_tavu = 0;
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;
	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	  }
	
	  k++;
	  if(k >= RUUDUNTAVULEVEYS-tavux) {  //vaihdettu == -> >= kuten aiemmin. ja poistettu ihan lopusta +1)
	    muokattava_tavu = 0;
	    break;
	  }
	}
      }
      //jos koko (osa)kuva näkyy ruudussa
      else {

	while(1) {  //Rivinpiirtolooppi
	  if( y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   >= 16000) {
	    for(;;) cout << "bmkuva5: " << kuva << ", x: " << x << ", y: " << y << ", nelio: " << osio.x << ", " << osio.y << ", " << osio.leveys << ", " << osio.korkeus
			 << ", lapinak: " << lapinak << ", mustapiirto: " << mustapiirto << endl;
	  }

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];

	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	  }
	  
	  k++;
	  if(k >= osio.leveys/4) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	      }
	    }
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+osio.y*kuva->tavuleveys+osiotavux+k];
	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  muokattava_tavu = muokattava_tavu >> bittisiirto;
	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	    if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	    else {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    }
	  }
	  k++;

	  if(k >= osio.leveys/4) {
	    muokattava_tavu = 0;

	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k+tavux >= alue_tavux and k+tavux <= alue_tavux+alue_tavuleveys) {
	      if(mustapiirto) vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] &= ~muokattava_tavu;
	      else {
		lapinak ?
		  vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
		  : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	      }
	    }
	    break;
	  }
	}
      }
    }
  }
}



void hahmoluokka::poista_bittikartta() {
  delete[] kuva->bittikartta;
}

void esineluokka::poista_bittikartta() {
  delete[] kuva->bittikartta;
}

void hahmoluokka::seuraava_kframe() {
  if(frame >= kframet[0] and frame < kframet[0]+kframet[1]) {
    frame++;
    if(frame == kframet[0] + kframet[1]) frame = kframet[0];
  }
  else if(frame >= kframet[2] and frame < kframet[2]+kframet[3]) {
    frame++;
    if(frame == kframet[2] + kframet[3]) frame = kframet[2];
  }
  else if(frame >= kframet[4] and frame < kframet[4]+kframet[5]) {
    frame++;
    if(frame == kframet[4] + kframet[5]) frame = kframet[4];
  }
  else if(frame >= kframet[6] and frame < kframet[6]+kframet[7]) {
    frame++;
    if(frame == kframet[6] + kframet[7]) frame = kframet[6];
  }
}

void hahmoluokka::hahmopiirto() {

  if(kavelee) {
    kavelylkount += kliikenopeus;
    kavelyfkount++;
    if(kavelyfkount == kframenopeus) {
      seuraava_kframe();
      kavelyfkount = 0;
    }
    if(kavelylkount > 100) {
      int liikemaara = 0;
      while(kavelylkount > 100) {
	kavelylkount -= 100;
	liikemaara++;
      }

      vector<kavelyohje>::iterator kiter = kavelyvec.begin();

      if(kiter->kliikemuutos != 999) {
	kliikenopeus = kiter->kliikemuutos;
	kiter->kliikemuutos = 999;
      }
      if(kiter->alkuframe != 999) {
	frame = kiter->alkuframe;
	kiter->alkuframe = 999;
      }
      if(kiter->flippaa.first < 2) {
	if(kiter->flippaa.first == 1) aseta_flip(true);
	if(kiter->flippaa.first == 0) aseta_flip(false);
	kiter->flippaa.first = 2;
	x += kiter->flippaa.second;
      }
      
      if     (kiter->paasuunta == 8) y -= liikemaara;
      else if(kiter->paasuunta == 9) {y -= liikemaara; x += liikemaara;}
      else if(kiter->paasuunta == 6) x += liikemaara;
      else if(kiter->paasuunta == 3) {y += liikemaara; x += liikemaara;}
      else if(kiter->paasuunta == 2) y += liikemaara;
      else if(kiter->paasuunta == 1) {y += liikemaara; x -= liikemaara;}
      else if(kiter->paasuunta == 4) x -= liikemaara;
      else if(kiter->paasuunta == 7) {y -= liikemaara; x -= liikemaara;}

      if(kiter->sivusuunta > 0) {
	kiter->suuntakountteri++;
	if(kiter->suuntakountteri == kiter->suuntapoikkeama) {
	  kiter->suuntakountteri = 0;
	  if     (kiter->sivusuunta == 8) {y -= 1;}
	  else if(kiter->sivusuunta == 6) {x += 1;}
	  else if(kiter->sivusuunta == 2) {y += 1;}
	  else if(kiter->sivusuunta == 4) {x -= 1;}
	}
      }

      if(
	 ((kiter->paasuunta >= 7) and y < kiter->y_paamaara) or
	 ((kiter->paasuunta%3 == 0) and x > kiter->x_paamaara) or
	 ((kiter->paasuunta <= 3) and (y > kiter->y_paamaara)) or
	 (((kiter->paasuunta-1)%3 == 0) and x < kiter->x_paamaara)
	  ) {
	if(kavelyvec.size() == 1) kavelee = false;
	if(kiter->loppuun_kesk) tkesk = true;
	if(kiter->loppuframe != 999) frame = kiter->loppuframe;
	kavelyvec.erase(kiter);
	kavelylkount = 0;
      }
    }
  }
  if(toiminta) {
    esinetoiminta toimintadata = (*toimintaptr)(toimintakountteri, toim_arg);
    if(toimintadata.ruudulla != 99) ruudulla = toimintadata.ruudulla;
    if(toimintadata.sammuta == true) {
      toiminta = false;
      toimintakountteri = 0;
    }
    else {
      if(toimintadata.x_abs != 999) x = toimintadata.x_abs;
      if(toimintadata.y_abs != 999) y = toimintadata.y_abs;
      if(toimintadata.x_muutos != 0) x += toimintadata.x_muutos;
      if(toimintadata.y_muutos != 0) y += toimintadata.y_muutos;
      toimintakountteri++;
      if(toimintakountteri == toimintakatto) toimintakountteri = 0;
    }
  }

  if(ruudulla == 0) return;
  if(framekierto.size() > 0) {
    if(fh_kountteri > 0) fh_kountteri--;

    if(fh_kountteri == 0) {
      if(fk_tauko == 0) {
	vector<int>::iterator fiter = framekierto.begin() + fk_kountteri;
	if(*fiter > 99) {
	  MIDASplaySample(*framekierto_sample, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
	}
	else if(*fiter == 99) {
	  fiter++;
	  fk_tauko = *fiter;
	  fk_kountteri++;
	}
	else {
	  frame = *fiter;
	}
	fk_kountteri++;
	if(fk_kountteri == framekierto.size()) fk_kountteri = 0;
      }
      else fk_tauko--;

      if(framehidastus > 0 and fh_kountteri == 0) fh_kountteri = framehidastus;
    }
  }

  if(vauhti > 0) {
    if(suunta > 0) {
      for(int i = 0; i != vauhti; i++) {
	switch(suunta) {
	case 1: x--; y++; break;
	case 2: y++; break;
	case 3: x++; y++; break;
	case 4: x--; break;
	case 6: x++; break;
	case 7: x--; y--; break;
	case 8: y--; break;
	case 9: x++; y--; break;
	}
      }
    }
  }

  if(kaksivarinen) {
    nelio kuvanelio;
    kuvanelio.x = frame * arkki_w;
    if(flipattu) kuvanelio.x = kuva->leveys-kuvanelio.x-arkki_w;
    kuvanelio.y = 0;
    kuvanelio.leveys = arkki_w;
    kuvanelio.korkeus = arkki_h;
    piirraosakuva(kuva, x, y, kuvanelio, lapinak, false);
    kuvanelio.y = arkki_h+1;
    piirraosakuva(kuva, x, y, kuvanelio, false, true); //oli y-1
  }
  else {
    nelio kuvanelio;
    kuvanelio.x = frame * arkki_w;
    if(flipattu) kuvanelio.x = kuva->leveys-kuvanelio.x-arkki_w;
    kuvanelio.y = 0;
    kuvanelio.leveys = arkki_w;
    kuvanelio.korkeus = arkki_h;
    piirraosakuva(kuva, x, y, kuvanelio, lapinak, false);
  }
}

void piirrakuva(bmkuva *kuva, int x, int y, bool lapinak) {

  if((x < 0 or x > RUUDUNLEVEYS) and (x+kuva->leveys < 0 or x+kuva->leveys > RUUDUNLEVEYS)) {
    return;
  }

  if(x < 0) {  //Aikamoinen purkkaratkaisu tämä...
    if(x % 4 == -1) x -= 2;
    else if(x % 4 == -3) x += 2;
  }

  int y_lahto = y*RUUDUNTAVULEVEYS;
  int tavux = x/4;
  
  if(x % 4 == 0) {  //Ei tarvitse mennä bittitasolle, joka tavussa neljä merkitsevää bittiä

    for(int i = 0; i != kuva->korkeus; i++) { //piirretään kuva rivi kerrallaan

      //Ei piirretä rivejä, jotka eivät osu näytölle
      if(y+i < 0) continue;
      if(y+i >= RUUDUNKORKEUS) break;
      
      if(x < 0) {
	for(int j = 0; j != kuva->tavuleveys+tavux; j++) {

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+j] |= kuva->bittikartta[i*kuva->tavuleveys-tavux+j]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+j] = kuva->bittikartta[i*kuva->tavuleveys-tavux+j];
	}
      }
      
      //Jos kuva menee ruudusta ohi oikealta
      else if((x + kuva->leveys) > RUUDUNLEVEYS) {
	
	for(int j = 0; j != (RUUDUNLEVEYS-x)/4; j++) { //loopataan niin monta kertaa kuin mitä kuvasta on näkyvissä

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+j]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+j];
	}
      }

      //jos koko kuva näkyy ruudussa tai on osin piilossa vasemmalla
      else {
	for(int j = 0; j != kuva->tavuleveys; j++) {

	  if(j == 0 or j == kuva->tavuleveys-1) {
	    if( y_lahto+i*RUUDUNTAVULEVEYS+tavux+j   < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+j   >= 16000) {
	      for(;;) cout << "bmkuva8: " << kuva << ", x: " << x << ", y: " << y << ", lapinak: " << lapinak << endl;
	    }
	  }
	  
	  lapinak ?
	  vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] |= kuva->bittikartta[i*kuva->tavuleveys+j]
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+j] = kuva->bittikartta[i*kuva->tavuleveys+j];
	}
      }
    }
  }
  
  else {  //Jos kuvan X-positio ei ole 4:llä jaollinen ja bittejä pitää siirtää...
    int bittisiirto = abs(x%4*2); //bittisirron mahdolliset arvot: 2, 4, 6

    for(int i = 0; i != kuva->korkeus; i++) { //piirretään kuva rivi kerrallaan

      //Ei piirretä rivejä, jotka eivät osu näytölle
      if(y+i < 0) continue;
      if(y+i >= RUUDUNKORKEUS) break;

      unsigned char ylibitit1 = 0;
      unsigned char ylibitit2 = 0;
  
      int k = 0;

      //Jos kuva menee ruudusta yli vasemmalta
      if(x < 0) {
	while(1) {  //Rivinpiirtolooppi

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys-tavux+k];
	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    lapinak ? 
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;

	  }
	  
	  k++;
	  if(k >= kuva->tavuleveys+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {
	      lapinak ?
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	    }
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys-tavux+k];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  if(k > 0) {
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	  }
	
	  k++;
	  if(k >= kuva->tavuleveys+tavux) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else { 
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    if(k > 0) {
	      lapinak ? 
		vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] |= muokattava_tavu
		: vfb[y_lahto+i*RUUDUNTAVULEVEYS+k-1] = muokattava_tavu;
	    }
	    break;
	  }
	}
      }
      
      //Jos kuva menee ruudusta ohi oikealta
      else if((x + kuva->leveys) > RUUDUNLEVEYS) {
	while(1) {  //Rivinpiirtolooppi

	  if( y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   < 0 or y_lahto+i*RUUDUNTAVULEVEYS+tavux+k   >= 16000) {
	    for(;;) cout << "bmkuva10: " << kuva << ", x: " << x << ", y: " << y << lapinak << endl;
	  }

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+k];

	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);

	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else { 
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2; 
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;

	  k++;
	  if(k >= (RUUDUNLEVEYS-x)/4+1) {
	    muokattava_tavu = 0;

	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+k];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  
	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4; 
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2;
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	
	  k++;
	  if(k >= (RUUDUNLEVEYS-x)/4+1) {
	    muokattava_tavu = 0;

	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    break;
	  }
	}
      }

      
      //jos koko kuva näkyy ruudussa
      else {
	while(1) {  //Rivinpiirtolooppi

	  unsigned char muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+k];

	  //ota ylijäämäbitit talteen ylibitit1:een	  
	  ylibitit1 = 0;
	  ylibitit1 = (ylibitit1 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit1 = (ylibitit1 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit1 = (ylibitit1 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  //laita ylibitit2:sta ylijäämäbitit paikalleen
	  if(bittisiirto == 2) {
	    if(ylibitit2) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else {
	    if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2;
	    if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	  
	  k++;

	  if(k >= kuva->tavuleveys) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit1) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else {
	      if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2;
	      if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    break;
	  }

	  muokattava_tavu = kuva->bittikartta[i*kuva->tavuleveys+k];
	  
	  //ota ylibitit talteen ylibitit2:een	  
	  ylibitit2 = 0;
	  ylibitit2 = (ylibitit2 & 0b11111110) | (muokattava_tavu & 0b00000001);
	  if(bittisiirto > 2) ylibitit2 = (ylibitit2 & 0b11111011) | (muokattava_tavu & 0b00000100);
	  if(bittisiirto == 6) ylibitit2 = (ylibitit2 & 0b11101111) | (muokattava_tavu & 0b00010000);

	  //shiftaa bittisiirto*pikseliä oikealle
	  muokattava_tavu = muokattava_tavu >> bittisiirto;

	  if(bittisiirto == 2) {
	    if(ylibitit1) muokattava_tavu |= 1 << 6;
	  }
	  else if(bittisiirto == 4) {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 6;
	  }
	  else {
	    if(ylibitit1 & (1 << 0))  muokattava_tavu |= 1 << 2;
	    if(ylibitit1 & (1 << 2))  muokattava_tavu |= 1 << 4;
	    if(ylibitit1 & (1 << 4))  muokattava_tavu |= 1 << 6;
	  }

	  lapinak ?
	    vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	    : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	
	  k++;

	  if(k >= kuva->tavuleveys) {
	    muokattava_tavu = 0;

	    //Rivin lopussa vielä viimeiset ylibitit paikalleen
	    if(bittisiirto == 2) {
	      if(ylibitit2) muokattava_tavu |= 1 << 6;
	    }
	    else if(bittisiirto == 4) {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 6;
	    }
	    else {
	      if(ylibitit2 & (1 << 0))  muokattava_tavu |= 1 << 2;
	      if(ylibitit2 & (1 << 2))  muokattava_tavu |= 1 << 4;
	      if(ylibitit2 & (1 << 4))  muokattava_tavu |= 1 << 6;
	    }
	    lapinak ?
	      vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] |= muokattava_tavu
	      : vfb[y_lahto+i*RUUDUNTAVULEVEYS+tavux+k] = muokattava_tavu;
	    break;
	  }
	}
      }
    }
  }
}

void esineluokka::esinepiirto() {
  if(toiminta) {
    esinetoiminta toimintadata = (*toimintaptr)(toimintakountteri);
    if(toimintadata.x_abs != 999) x = toimintadata.x_abs;
    if(toimintadata.y_abs != 999) y = toimintadata.y_abs;
    if(toimintadata.x_muutos != 0) x += toimintadata.x_muutos;
    if(toimintadata.y_muutos != 0) y += toimintadata.y_muutos;
    if(toimintadata.ruudulla != 99) ruudulla = toimintadata.ruudulla;
    toimintakountteri++;
    if(toimintakountteri == toimintakatto) toimintakountteri = 0;
  }

  if(ruudulla == 0) return;
   
  if(vauhti > 0) {
    vkountteri--;
    if(vkountteri <= 0) {
      int muutos = 1;
      if(turbo > 0) muutos += turbo;
      if(suunta > 0) {
	switch(suunta) {
	case 1: x -= muutos; y += muutos; break;
	case 2: y += muutos; break;
	case 3: x += muutos; y += muutos; break;
	case 4: x -= muutos; break;
	case 6: x += muutos; break;
	case 7: x -= muutos; y -= muutos; break;
	case 8: y -= muutos; break;
	case 9: x += muutos; y -= muutos; break;
	}
      }
      vkountteri = vauhti;
    }
  }

  if(vauhti == -99) {
    int muutos = 1 + turbo;
    if(suunta > 0) {
      switch(suunta) {
      case 1: x -= muutos; y += muutos; break;
      case 2: y += muutos; break;
      case 3: x += muutos; y += muutos; break;
      case 4: x -= muutos; break;
      case 6: x += muutos; break;
      case 7: x -= muutos; y -= muutos; break;
      case 8: y -= muutos; break;
      case 9: x += muutos; y -= muutos; break;
      }
    }
  }

  if(rajattu) {
    if(kaksivarinen) {
      nelio kuvanelio;
      kuvanelio.x = 0;
      kuvanelio.y = 0;
      kuvanelio.leveys = kuva->leveys;
      kuvanelio.korkeus = (kuva->korkeus)/2;
      piirraosakuva_rajattu(kuva, x, y, kuvanelio, lapinak, false, rajausnelio);
      kuvanelio.y = kuvanelio.korkeus;
      piirraosakuva_rajattu(kuva, x, y, kuvanelio, false, true, rajausnelio);
    }
    else {
      nelio rnelio;
      rnelio.leveys = kuva->leveys;
      rnelio.korkeus = kuva->korkeus;
      piirraosakuva_rajattu(kuva, x, y, rnelio, lapinak, false, rajausnelio);
    }
  }
  else {
    if(kaksivarinen) {
      nelio kuvanelio;
      kuvanelio.x = 0;
      kuvanelio.y = 0;
      kuvanelio.leveys = kuva->leveys;
      kuvanelio.korkeus = (kuva->korkeus)/2;
      piirraosakuva(kuva, x, y, kuvanelio, lapinak, false);
      kuvanelio.y = kuvanelio.korkeus;
      piirraosakuva(kuva, x, y, kuvanelio, false, true);
    }
    else piirrakuva(kuva, x, y, lapinak);
  }
}

void poistatavu(int x, int y) {
  if(x > 80 or x < 0 or y > 200 or y < 0) return;
  vfb[y*80+x] = 0;
  return;
}

void piirrapikseli(int x, int y) {
  unsigned char piirtotavu = 0b01000000;
  int jj = x % 4;
  if(jj == 1) piirtotavu = 0b00010000;
  else if(jj == 2) piirtotavu = 0b00000100;
  else if(jj == 3) piirtotavu = 0b00000001;
  int kohdetavu = y*RUUDUNTAVULEVEYS+x/4;
  if(kohdetavu > 0 and kohdetavu < 16000) {
    vfb[kohdetavu] |= piirtotavu;
  }
  return;
}

void poistapikseli(int x, int y) {
  unsigned char piirtotavu = 0b10111111;
  int jj = x % 4;
  if(jj == 1) piirtotavu = 0b11101111;
  else if(jj == 2) piirtotavu = 0b11111011;
  else if(jj == 3) piirtotavu = 0b11111110;
  int kohdetavu = y*RUUDUNTAVULEVEYS+x/4;
  if(kohdetavu > 0 and kohdetavu < 16000) {
    vfb[kohdetavu] &= piirtotavu;
  }
  return;
}

void piirratavu(int x, int y, bool colour) {
  vfb[y*80+x] = colour ? 85 : 0;
}

void tyhjenna_ruutu(void) {
  memset(cga_osoite, 0, 16000);
}

void tyhjenna_vfb(void) {
  memset(vfb, 0, 16000);
}


void piirraruutu(void) {
  for(int i = 0, j = 0; i < 201; i += 2, j++) {
    memcpy(cga_osoite+j*80, vfb+i*80, 80);
  }
  for(int i = 1, j = 0; i < 201; i += 2, j++) {
    memcpy(cga_osoite+j*80+8192, vfb+i*80, 80);  //parilliset scanlinet pistetään ylempiin muistiosoitteisiin
  }
}

#define PIIRRA_KAIKKI do {	 \
  tyhjenna_ruutu();              \
  tyhjenna_vfb();                \
  taustakuva = true;             \
  taustakuva_ptr = &peri3_bm;    \
  prota3.ruudulla = 1;           \
  prota3.frame = 1;              \
  prota3.x = 91;                 \
  prota3.y = 82;                 \
  prota3.frame = 4;              \
  plintu.ruudulla = 1;           \
  plintu.x = 130;                \
  plintu.y = 20;                 \
  plintu.frame = 6;              \
  plintu.aseta_flip(true);       \
  drone.ruudulla = 1;            \
  drone.x = 95;                  \
  drone.y = 10;                  \
  drone.frame = 0;               \
  erikoisefekti = false;         \
} while (0)

#define KAIKKI_POIS do {         \
  erikoisefekti = false;         \
  taustakuva = false;            \
  kaikki_pois_ruudulta();        \
  tyhjenna_vfb();                \
  tyhjenna_ruutu();              \
} while (0)



void viivapiirto(int x1, int y1, int x2, int y2) {
  double kaltevuus = (double(x1-x2))/(double(y1-y2));
  double kountteri;

  int y_ero;
  if(y1 > y2) y_ero = y1-y2;
  else y_ero = y2-y1;

  for(int i = 0; i != y_ero; i++) {
    piirrapikseli(x1+(int(kaltevuus*(double)i)), y1+i);
  }
}

void viivapiirto2(int x1, int y1, int x2, int y2) {
  double kaltevuus = (double(y1-y2))/(double(x1-x2));
  double kountteri;

  int x_ero;
  if(x1 > x2) x_ero = x1-x2;
  else x_ero = x2-x1;

  for(int i = 0; i != x_ero; i++) {
    piirrapikseli(x1+(int(kaltevuus*(double)i)), y1+i);
  }
}

void teksliike(int aika) {
  if(aika%2==1) {
    lopputeks.y--;
  }
}

void ambuliike3(int aika) {
  aika = 201-aika;
  aika = aika%40;
  aika = aika/(double(40)/double(21));

  if(ambu4.x >= -30) {
    if(aika == 0) {
      ambu3.ruudulla = 1;
      ambu3.frame = 0;
      ambu3.x = 271-ambu3.arkki_w;
      ambu3.y = 210-ambu3.arkki_h;
    }
    else if(aika == 1) {
      ambu3.frame = 1;
      ambu3.x = 257-ambu3.arkki_w;
      ambu3.y = 196-ambu3.arkki_h;
    }
    else if(aika == 2) {
      ambu3.frame = 2;
      ambu3.x = 236-ambu3.arkki_w;
      ambu3.y = 187-ambu3.arkki_h;
    }
    else if(aika == 3) {
      ambu3.frame = 3;
      ambu3.x = 219-ambu3.arkki_w;
      ambu3.y = 180-ambu3.arkki_h;
    }
    else if(aika == 4) {
      ambu3.frame = 4;
      ambu3.x = 207-ambu3.arkki_w;
      ambu3.y = 172-ambu3.arkki_h;
    }
    else if(aika == 5) {
      ambu3.frame = 5;
      ambu3.x = 195-ambu3.arkki_w;
      ambu3.y = 165-ambu3.arkki_h;
    }
    else if(aika == 6) {
      ambu3.frame = 6;
      ambu3.x = 183-ambu3.arkki_w;
      ambu3.y = 156-ambu3.arkki_h;
    }
    else if(aika == 7) {
      ambu3.frame = 7;
      ambu3.x = 169-ambu3.arkki_w;
      ambu3.y = 151-ambu3.arkki_h;
    }
    else if(aika == 8) {
      ambu3.frame = 8;
      ambu3.x = 153-ambu3.arkki_w;
      ambu3.y = 143-ambu3.arkki_h;
    }
    else if(aika == 9) {
      ambu3.frame = 9;
      ambu3.x = 143-ambu3.arkki_w;
      ambu3.y = 139-ambu3.arkki_h;
    }
    else if(aika == 10) {
      ambu3.ruudulla = 0;
      ambu4.ruudulla = 2;
      ambu4.frame = 0;
      ambu4.x = 128-ambu4.arkki_w;
      ambu4.y = 132-ambu4.arkki_h;
    }
    else if(aika == 11) {
      ambu4.x = 117-ambu4.arkki_w;
      ambu4.y = 129-ambu4.arkki_h;
    }
    else if(aika == 12) {
      ambu4.frame = 1;
      ambu4.x = 106-ambu4.arkki_w;
      ambu4.y = 127-ambu4.arkki_h;
    }
    else if(aika == 13) {
      ambu4.x = 94-ambu4.arkki_w;
      ambu4.y = 125-ambu4.arkki_h;
    }
    else if(aika == 14) {
      ambu4.frame = 2;
      ambu4.x = 82-ambu4.arkki_w;
      ambu4.y = 123-ambu4.arkki_h;
    }
    else if(aika == 15) {
      ambu4.x = 57-ambu4.arkki_w;
      ambu4.y = 120-ambu4.arkki_h;
    }
    else if(aika == 16) {
      ambu4.x = 47-ambu4.arkki_w;
      ambu4.y = 118-ambu4.arkki_h;
    }
    else if(aika == 17) {
      ambu4.x = 34-ambu4.arkki_w;
      ambu4.y = 117-ambu4.arkki_h;
    }
    else if(aika == 18) {
      ambu4.x = 23-ambu4.arkki_w;
      ambu4.y = 115-ambu4.arkki_h;
    }
    else if(aika == 19) {
      ambu4.x = 10-ambu4.arkki_w;
      ambu4.y = 114-ambu4.arkki_h;
    }
    else if(aika == 20) {
      ambu4.ruudulla = 0;
      ambu4.x = -40;
    }
  }
}

void kanto(int aika) {
  prota4.x = ambuh.x + 12;
  prota4.y = ambuh.y + 16;
}

void ambuliike2(int aika) {
  if(ambu2.x < RUUDUNLEVEYS) ambu2.x++;
}

void ambuliike1(int aika) {
  if(ambu2.x > 204) ambu2.x--;
}
 
void auto2(int aika) {
  tyhjenna_vfb();
  piirrakuva(&ambu_bm, RUUDUNLEVEYS-(70-aika)*4, RUUDUNKORKEUS-58, false);
  if(aika%8 > 4) {
    for(int i = 0; i != 8; i++) {
      for(int j = 32; j != 48; j++) {
	poistapikseli(RUUDUNLEVEYS-(70-aika)*4+j, RUUDUNKORKEUS-58+i);
      }
    }
  }
}

void mittari(int aika) {
  aika = 100-aika;
  if(aika%10 > 5) piirrakuva(&sydan_bm, 41, 151, false);
  if(aika%7==0) MIDASplaySample(lyhyt_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  
  for(int i = 0; i != 30+aika/2; i++) {
    for(int j = 0; j != 10; j++) {
      piirrapikseli(66+i, 60+j);
    }
  }

  for(int i = 0; i != 10+aika/4; i++) {
    for(int j = 0; j != 10; j++) {
      piirrapikseli(66+i, 116+j);
    }
  }
}


int rivit[17][3];

int arvo_merkit() {
  int arpa = rand()%5;
  if(arpa == 0) return 42;
  else if(arpa == 1) return 85;
  else if(arpa == 2) return 170;
  else if(arpa == 3) return 172;
  else if(arpa == 4) return 186;
  return 187;
}

void init_rivit() {
  for(int i = 0; i != 17; i++) {
    for(int j = 0; j != 3; j++) {
      rivit[i][j] = arvo_merkit();
    }
  }
}

void piirrarivi(int *rivi, int rivino) {
  for(int i = 0; i != 3; i++) {
    for(int j = 0; j != 8; j++) {
      if(rivi[i] & (1 << j)) piirrapikseli(cz_poyta.x+43+j+i*8, cz_poyta.y+6+rivino);
    }
  }
}

void nayttorivit(int aika) {
  for(int j = 0; j != 2; j++) {
    int vara[3];

    vara[0] = rivit[0][0];
    vara[1] = rivit[0][1];
    vara[2] = rivit[0][2];
    if(j == 1) piirrarivi(rivit[0], 0);
    for(int i = 1; i != 17; i++) {
      if(j == 1) piirrarivi(rivit[i], i);
      rivit[i-1][0] = rivit[i][0];
      rivit[i-1][1] = rivit[i][1];
      rivit[i-1][2] = rivit[i][2];
    }
    rivit[16][0] = vara[0];
    rivit[16][1] = vara[1];
    rivit[16][2] = vara[2];
  }
}

void kaatuu(int aika) {
  MIDASplaySample(ovi1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  aika = 36-efektikountteri;

  if(aika < 35) {
    if(aika == 34) {
      tyhjenna_ruutu();
      tyhjenna_vfb();
    }
    piirrakuva(&peri3_bm, 0, 0-aika*6, false);
    prota3.y = 82-aika*6;
    prota3.hahmopiirto();
    plintu.y = 20-aika*6;
    plintu.hahmopiirto();
    drone.y = 10-aika*6;
    drone.hahmopiirto();
    piirrakuva(&kaatuu_bm, 0, RUUDUNKORKEUS-aika*6, false);
  }
}

void defai(int aika) {
  if(aika == 70 or aika == 90 or aika == 110 or aika == 130) {
    if(tarinanvaihe > 1000) {
     piirrakuva(&defai_bm, 79, 82, false);
    }
    else piirrakuva(&fehler_bm, 110, 82, false);
    MIDASplaySample(syspiip_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(aika == 80 or aika == 100 or aika == 120 or aika == 140) {
    tyhjenna_ruutu();
    tyhjenna_vfb();
  }
  if(aika == 60) tkesk = true;
}

void eegeff(int aika) {
  if(aika%3 == 0) {
    eegpeite.x++;
    MIDASplaySample(lyhyt_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
}

void viivat_piirtofunktio(int rivi) {
  for(int j = rivi; j < rivi+4; j++) {
    for(int i = 0; i != RUUDUNLEVEYS; i++) {
      piirrapikseli(i, j);
    }
  }
  for(int j = rivi+5; j < rivi+9; j += 2) {
    for(int i = 0; i != RUUDUNLEVEYS; i++) {
      piirrapikseli(i, j);
    }
  }
}

void viivat(int aika) {
  for(int i = 5; i < RUUDUNKORKEUS-10; i += 24) {
    viivat_piirtofunktio(i);
  }
}

void viivat2(int aika) {
  for(int i = aika % 24; i < RUUDUNKORKEUS-10; i += 24) {
    viivat_piirtofunktio(i);
  }
}

void bzz(int aika) {
  aivobzz.ruudulla = 1;
  int luku = rand()%29;
  if(luku < 3) {
    aivobzz.frame = 0;
    MIDASplaySample(bzz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(luku < 6) aivobzz.frame = 1;
  else if(luku < 9) aivobzz.frame = 2;
  else aivobzz.ruudulla = 0;
}

void bzz2(int aika) {
  tyhjenna_ruutu();
  tyhjenna_vfb();
  
  if(aika%4 == 0) {
    piirrakuva(&aivobzz2_bm, 103, 23, false);
  }
  MIDASplaySample(bzz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  piirrakuva(&aivot_bm, 0, 0, true);
}

void tarina(int aika) {
  if(aika == 80 or aika == 50 or aika == 20) MIDASplaySample(bzz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);

  if(aika > 10 and aika < 20) {
    if(aika % 2 == 0) prota2.x++;
    else prota2.x--;
  }

  if(aika > 40 and aika < 50) {
    if(aika % 2 == 0) prota2.x++;
    else prota2.x--;
  }

  if(aika > 70 and aika < 80) {
    if(aika % 2 == 0) prota2.x++;
    else prota2.x--;
  }
}

void plinnunrata2(int aika) {
  aika = 70-efektikountteri;

  if(aika < 30) {
    plintu.frame = aika%4;
    if(plintu.frame == 3) plintu.frame = 1;
  }
  
  if(aika == 10) {
    plintu.aseta_flip(false);
    plintu.suunta = 3;
    plintu.vauhti = 2;
  }
  if(aika == 20) {
    plintu.aseta_flip(true);
    plintu.suunta = 1;
  }
  if(aika == 30) {
    plintu.aseta_flip(true);
    plintu.suunta = 0;
    plintu.frame = 6;
  }
}

void plinnunrata(int aika) {
  aika = 70-efektikountteri;

  if(aika > 10) {
    plintu.frame = aika%4;
    if(plintu.frame == 3) plintu.frame = 1;
  }
  
  if(aika == 10) {
    plintu.aseta_flip(false);
    plintu.suunta = 9;
    plintu.vauhti = 2;
  }
  if(aika == 20) {
    plintu.aseta_flip(true);
    plintu.suunta = 7;
  }

  if(aika == 30) {
    paaylos.ruudulla = 0;
    plintu.ruudulla = 0;
  }
}

esinetoiminta potku(int kountteri) {
  esinetoiminta data;
  potkula.x -= 3;
  if(kountteri > 54 and kountteri < 72) data.y_muutos = -1;
  if(kountteri > 80 and kountteri < 92) data.y_muutos = +1;
  return data;
}

void ampuminen(int aika) {
  if(aika >= 50 and aika <= 53) {
    viivapiirto(lintu1.x+11, lintu1.y+3, 268, 174);
  }
  else if(aika >= 40 and aika <= 43) {
    viivapiirto(lintu1.x+11, lintu1.y+3, 293, 168);
  }
  else if(aika >= 60 and aika <= 63) {
    viivapiirto(lintu1.x+11, lintu1.y+3, 271, 189);
  }

  if(aika == 53 or aika == 43 or aika == 63) MIDASplaySample(laser_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
}

void ampuminen2(int aika) {
  if(aika >= 50 and aika <= 53) viivapiirto(lintu1.x+11, lintu1.y+3, 271, 189);
  else if(aika >= 40 and aika <= 43) viivapiirto(lintu1.x+11, lintu1.y+3, 268, 174);
  else if(aika >= 70 and aika <= 73) viivapiirto(lintu1.x+11, lintu1.y+3, 293, 168);
  if(aika == 50) { prota1.kavelee = true; prota1.aseta_flip(false); prota1.x += 4; }
  if(aika == 37) MIDASplaySample(ankpuhe2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 53 or aika == 43 or aika == 73) MIDASplaySample(laser_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
}
void ampuminen3(int aika) {
  if(aika >= 50 and aika <= 53) for(int i = 0; i != RUUDUNLEVEYS-lintu2.x-15; i++) piirrapikseli(lintu2.x+15+i, lintu2.y+2);
  else if(aika >= 70 and aika <= 73) for(int i = 0; i != RUUDUNLEVEYS-lintu2.x-15; i++) piirrapikseli(lintu2.x+15+i, lintu2.y+2);
  if(aika == 53 or aika == 73) MIDASplaySample(laser_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
}

void ampuminen4(int aika) {
  if(aika >= 7 and aika <= 10) viivapiirto2(drone.x+11, drone.y+7, ambu2.x-30, ambu2.y+50);
  else if(aika >= 17 and aika <= 20) viivapiirto2(drone.x+11, drone.y+7, ambu2.x-30, ambu2.y+50);
  else if(aika >= 27 and aika <= 30) viivapiirto2(drone.x+11, drone.y+7, ambu2.x-30, ambu2.y+50);
  if(aika == 10 or aika == 20 or aika == 30) MIDASplaySample(laser_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
}

void aaltopiirto(int x, int y) {
  for(int i = 0; i != 4; i++) {
    piirrapikseli(x, y);
    x += 4;
  }
  x -= 14;
  y++;
  for(int i = 0; i != 4; i++) {
    piirrapikseli(x, y);
    x += 4;
  }
}

void aaltofunktio2(int aika) {
  aika = 10000-efektikountteri;
  aika = aika%30;
  aika = aika/(30/3);
  if(aika <= 1) { aaltopiirto(28, 142); aaltopiirto(16, 176); aaltopiirto(91, 164); aaltopiirto(50, 160); lintu2.y = 152; }
  if(aika >= 2) { aaltopiirto(28, 143); aaltopiirto(16, 177); aaltopiirto(91, 165); aaltopiirto(50, 161); lintu2.y = 153; }
}

esinetoiminta aaltofunktio(int kountteri) {
  esinetoiminta data;
  if(kountteri == 0) {
      data.x_abs = 48;
      data.y_abs = 139;
      data.ruudulla = 4;
  }
  if(kountteri < 44 and kountteri % 4 == 0) data.x_muutos = 1;
  else if(kountteri == 44) data.ruudulla = 0;
  return data;
}

esinetoiminta liplapfunktio(int kountteri) {
  esinetoiminta data;
  if(kountteri == 6) {
    data.x_muutos = 1;
    return data;
  }
  else if(kountteri == 0) {
    data.x_muutos = -1;
    return data;
  }
  return data;
}

int ellipsin_x(int y, int xk, int yk, int a, int b) {
  return static_cast<int>(sqrt((-(pow(y-yk, 2)/pow(b, 2))+1)*pow(a, 2)-pow(xk, 2)));
}

esinetoiminta linnunrata(int y, int toim_arg) {
  esinetoiminta data;
  if(y == 99) {
    data.sammuta = true;
    data.ruudulla = 0;
  }
  int y2 = y;
  y = 84-y;
  if(toim_arg == 0) data.x_abs = ellipsin_x(y, 0, 0, 190, 110)-130+(static_cast<int>(y2*1.01));
  else if(toim_arg == 1) data.x_abs = ellipsin_x(y, 0, 0, 190, 110)-130+(static_cast<int>(y2*2));
  else if(toim_arg == 2) data.x_abs = ellipsin_x(y, 0, 0, 190, 110)-130+(static_cast<int>(y2*1.02));
  data.y_abs = y;
  if(toim_arg == 1) data.y_abs -= 20;
  if(toim_arg == 2) data.y_abs -= 40;
  return data;
}

void kasi_liike1(int aika) {
  if(kasi1.x > 193) kasi1.x -= 3;
  if(kasi1.x <= 227 and kasi1.x > 220) {
    plugb.ruudulla = 1;
    pluga.ruudulla = 3;
  }
}

void kasi_liike2(int aika) {
  aika = 200-aika;
  if(kasi2.x > 248) kasi2.x -= 3;
  if(aika > 120 and kasi2.y < 20) {
    kasi2.x--;
    kasi2.y++;
  }
  if(aika == 136) {
    ilme.ruudulla = 1;
    MIDASplaySample(bzz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(aika >= 146 and aika <= 150) {
    ilme.ruudulla = 0;
  }

}

void kasi_liike3(int aika) {
  if(kasi3.x < RUUDUNLEVEYS) {
    kasi3.x += 3;
    kasi3.y -= 1;
  }
  else tkesk = true;
}

void kasi_liike4(int aika) {
  if(kasi1.x < RUUDUNLEVEYS) {
    kasi1.x += 3;
  }
  else tkesk = true;
  if(kasi1.x <= 227 and kasi1.x > 220) {
    plugb.ruudulla = 0;
    pluga.ruudulla = 0;
    osa.ruudulla = 0;
  }
}


struct puhe {
  int x;
  int y;
  int pituus;
};
puhe puhe1 = { 194,  77, 5, };
puhe puhe2 = { 158,  93, 2, };
puhe puhe3 = { 137, 156, 5, };
puhe puhe4 = { 95,  156, 2, };
puhe puhe5 = { 146, 151, 2, };
puhe puhe6 = { 198, 160, 2, };
puhe *puheptr;

void puhetta(int aika) {
  if(aika%8 < 4) {
    for(int i = 0; i != puheptr->pituus; i++) {
      piirrapikseli(puheptr->x+i, puheptr->y);
    }
  }
}

void puhetta2(int aika) {
  if(aika%8 < 4) {
    piirrapikseli(230, 92);
    piirrapikseli(231, 92);
    piirrapikseli(240, 91);
    piirrapikseli(241, 91);
  }
}

void puhetta3(int aika) {
  if(aika%8 < 4) {
    piirrapikseli(224, 104);
    piirrapikseli(225, 104);
    piirrapikseli(226, 104);
    piirrapikseli(227, 104);
  }
}

pair<int, int> vvalodata[27] = {
  make_pair(245, 101),
  make_pair(245, 105),
  make_pair(245, 109),
  make_pair(245, 113),
  make_pair(245, 117),
  make_pair(269, 101),
  make_pair(269, 105),
  make_pair(269, 109),
  make_pair(269, 113),
  make_pair(293, 101),
  make_pair(293, 105),
  make_pair(293, 109),
  make_pair(293, 113),
  make_pair(317, 101),
  make_pair(317, 105),
  make_pair(317, 109),
  make_pair(317, 113),
  make_pair(283, 126),
  make_pair(283, 131),
  make_pair(283, 136),
  make_pair(283, 141),
  make_pair(283, 146),
  make_pair(307, 126),
  make_pair(307, 131),
  make_pair(307, 136),
  make_pair(307, 141),
  make_pair(307, 146),
};

int vvalodata2[54];
int vvalodata3[54];
int vvalodata4[54];
bool vasenvalot[6] = {true, false, true, true, false, true};

void vilkkuvalot(int aika) {
  if(tarinanvaihe > 1000) {
    nayttorivit(aika);
  }
    for(int i = 0; i != 27; i++) {
      if(rand()%10 == 1) {
	if(rand()%2 == 1) {
	  int korkeus = 2;
	  if(vvalodata[i].second > 120) korkeus = 3;
	  vvalodata2[i*2] = rand()%16 + vvalodata[i].first;
	  vvalodata2[i*2+1] = rand()%korkeus + vvalodata[i].second;
	}
	else vvalodata2[i*2] = 0;
      }
    }
    for(int i = 0; i != 27; i++) {
      if(rand()%40 == 1) {
	if(rand()%2 == 1) {
	  int korkeus = 2;
	  if(vvalodata[i].second > 120) korkeus = 3;
	  vvalodata3[i*2] = rand()%16 + vvalodata[i].first;
	  vvalodata3[i*2+1] = rand()%korkeus + vvalodata[i].second;
	}
	else vvalodata3[i*2] = 0;
      }
    }

    for(int i = 0; i != 27; i++) {
      if(rand()%40 == 1) {
	if(rand()%2 == 1) {
	  int korkeus = 2;
	  if(vvalodata[i].second > 120) korkeus = 3;
	  vvalodata4[i*2] = rand()%16 + vvalodata[i].first;
	  vvalodata4[i*2+1] = rand()%korkeus + vvalodata[i].second;
	}
	else vvalodata4[i*2] = 0;
      }
    }
    
  for(int i = 0; i < 54; i += 2) {
    if(vvalodata2[i] == 0) continue;
    if(vvalodata2[i] >= RUUDUNLEVEYS) continue;
    piirrapikseli(vvalodata2[i], vvalodata2[i+1]);

    if(vvalodata3[i] == 0) continue;
    if(vvalodata3[i] >= RUUDUNLEVEYS) continue;
    piirrapikseli(vvalodata3[i], vvalodata3[i+1]);

    if(vvalodata4[i] == 0) continue;
    if(vvalodata4[i] >= RUUDUNLEVEYS) continue;
    piirrapikseli(vvalodata4[i], vvalodata4[i+1]);
  }

  for(int i = 0; i != 6; i++) {
    if(rand()%40 == 1)
      vasenvalot[i] == false ? vasenvalot[i] = true : vasenvalot[i] = false;
    if(vasenvalot[i] == true)
      piirrapikseli(103, 98+i*6);
  }

  if(rand()%40 == 1) {
    for(int i = 100; i != 111; i++) {
      for(int j = 67; j != 82; j++) {
	piirrapikseli(j, i);
      }
    }
  }
  
}

void dronebeep() {
  int valo = rand()%7;
  piirrapikseli(drone.x + 8 + valo, drone.y + 4);
}

int beep1[] = {0,1,1,0,2,0,2,1,0,1,2,1,0,1,2,0,1,2,2,2,0,0,0,2,0,0,2,0,0,2,1,2,1,1,1,2,0,0,2,1,0,3};
int beep2[] = {1,0,0,2,0,0,2,0,0,0,2,1,0,1,0,2,1,1,1,2,0,1,0,2,1,0,0,2,0,0,2,0,1,3};
int beep3[] = {0,0,0,1,2,0,1,2,0,1,1,0,2,0,1,2,0,0,1,2,1,2,1,2,0,1,2,1,0,1,2,0,1,2,0,1,2,2,0,1,2,0,0,1,2,1,2,1,1,1,2,1,0,0,0,2,0,1,2,0,0,0,0,2,1,0};
int beep4[] = {0,1,0,0,2,0,1,2,0,0,2,0,1,0,0,2,0,1,0,0,2,0,0,2,0,0,0,2,1,2,0,1,2,1,0,1,2,0,1,2,0,1,2,2,0,0,0,0,2,0,2,0,1,0,2,1,1,1,2,0,0,2,0,0,2,1,0,2,0,0};

void piipluku(int aika) {
  if(aika%4 == 0) {
    if(*piipptr == 0) {
      dronebeep();
      MIDASplaySample(lyhyt_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    }
    else if(*piipptr == 1) {
      dronebeep();
      MIDASplaySample(pitka_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    }
    else if(*piipptr == 3) {
      erikoisefekti = false;
    }
    piipptr++;
  }
}

void linnunlaulu2(int aika) {
  aika = 500-efektikountteri;

  if(aika == 1) MIDASplaySample(lintu1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 1 or aika == 6 or aika == 12 or aika == 18) plintu.frame = 7;
  if(aika == 3 or aika == 9 or aika == 15 or aika == 22) plintu.frame = 6;

  if(aika == 51) MIDASplaySample(lintu4_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 51 or aika == 56 or aika == 62 or aika == 68) plintu.frame = 7;
  if(aika == 53 or aika == 59 or aika == 65 or aika == 72) plintu.frame = 6;

  if(aika == 111) MIDASplaySample(lintu5_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 111 or aika == 116 or aika == 122 or aika == 128) plintu.frame = 7;
  if(aika == 113 or aika == 119 or aika == 125 or aika == 132) plintu.frame = 6;
  
  if(aika == 140) plintu.frame = 4;
  if(aika == 160) plintu.frame = 3;
  if(aika == 180) plintu.frame = 4;

  if(aika == 200) {
    plintu.frame = 6;
    tkesk = true;
  }
}

void linnunlaulu1(int aika) {
  aika = 500-efektikountteri;

  if(aika == 1) MIDASplaySample(lintu1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 1 or aika == 6 or aika == 12 or aika == 18) plintu.frame = 7;
  if(aika == 3 or aika == 9 or aika == 15 or aika == 22) plintu.frame = 6;

  if(aika == 51) MIDASplaySample(lintu2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 51 or aika == 56 or aika == 62 or aika == 68) plintu.frame = 7;
  if(aika == 53 or aika == 59 or aika == 65 or aika == 72) plintu.frame = 6;

  if(aika == 111) MIDASplaySample(lintu3_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  if(aika == 111 or aika == 116 or aika == 122 or aika == 128) plintu.frame = 7;
  if(aika == 113 or aika == 119 or aika == 125 or aika == 132) plintu.frame = 6;
  
  if(aika == 140) plintu.frame = 3;
  if(aika == 160) plintu.frame = 5;
  if(aika == 180) plintu.frame = 3;

  if(aika == 200) {
    plintu.frame = 6;
    tkesk = true;
  }
}

void hinousu(int aika) {
  if(prota1.y > 92) prota1.y--;
  if(prota1.y == 102) {
    hikansi.ruudulla = 3;
    hikansi.x = 91;
    hikansi.y = 137;
  }
  if(hikansi.ruudulla == 3) {
    if(hikansi.y > 127) hikansi.y--;
  }
  for(int i = 144; i != 144+38; i++) {
    for(int j = 92/4; j != 128/4; j++)
      piirratavu(j, i, false);
  }
}


void thovi_auki(int aika) {
  aika = ((1000-aika)%20)/(double(20)/double(8));
  thovi.frame = aika;
}

void thovi_kiinni(int aika) {
  aika = ((1000-aika)%20)/(double(20)/double(8));
  thovi.frame = 7-aika;
}

void hovi_auki(int aika) {
  aika = 1000-aika;
  aika = aika%20;
  aika = aika/(double(20)/double(6));

  hisovi.frame = aika;
}

void hovi_kiinni(int aika) {
  aika = ((1000-aika)%20)/(double(20)/double(6));
  hisovi.frame = 5-aika;
}

void valofunktio(int x, int y, bool himmea) {
  int x2 = x;
  for(int i = 0; i < 15; i++) {
    if(!himmea or i%2 == 0) piirrapikseli(x2, y);
    x2++;
    if((i-2)%3 == 0) {
      y++;
      x2 = x;
    }
  }
}

void kaytavavalot(int aika) {
  aika = 1000-efektikountteri;
  aika = aika%30;
  aika = aika/(30/14);

  int x;
  int y;
  int erotin = 4;
  bool kahdet = false;
  if(taustakuva_ptr == &kaytava_bm) {
    x = 10;
    y = 118;
    kahdet = true;
  }
  else if(taustakuva_ptr == &hissi_bm) {
    x = 23;
    y = 77;
  }
  else if(taustakuva_ptr == &ylakerta_bm) {
    x = 204;
    y = 83;
  }

  if(aika == 0) valofunktio(x, y, true);
  else if(aika == 1) { valofunktio(x, y, false); valofunktio(x+1*erotin, y, true); }
  else if(aika >= 2 and aika <= 6) {
    valofunktio(x+(aika-2)*erotin, y, true);
    valofunktio(x+(aika-1)*erotin, y, false);
    valofunktio(x+aika*erotin, y, true);
  }
  else if(aika == 7) { valofunktio(x+(aika-2)*erotin, y, true); valofunktio(x+(aika-1)*erotin, y, false); }
  else if(aika == 8) { valofunktio(x+(aika-2)*erotin, y, true); }

  if(kahdet) {
    x = 279;
    if(aika == 0) valofunktio(x, y, true);
    else if(aika == 1) { valofunktio(x, y, false); valofunktio(x+1*erotin, y, true); }
    else if(aika >= 2 and aika <= 6) {
      valofunktio(x+(aika-2)*erotin, y, true);
      valofunktio(x+(aika-1)*erotin, y, false);
      valofunktio(x+aika*erotin, y, true);
    }
    else if(aika == 7) { valofunktio(x+(aika-2)*erotin, y, true); valofunktio(x+(aika-1)*erotin, y, false); }
    else if(aika == 8) { valofunktio(x+(aika-2)*erotin, y, true); }
  }
  
}

void r_aaltofunktio(int aika) {

  aika = 230-aika;

  if(aika == 10 or aika == 60 or aika == 130) MIDASplaySample(radio_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  
  if(aika >= 60 and aika <= 110) aika -= 50;
  if(aika >= 130 and aika <= 180) aika -= 120;

  if(aika >= 10 and aika <= 40) {
    int sade = aika*2; //oli +20
    for(int y = -10-sade/4; y != 10+sade/4; y++) {
      int x = sqrt(abs(-(pow(y, 2)) + pow(sade, 2)));
      piirrapikseli(x+156, y+90);
      piirrapikseli(x+157, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+156, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+157, y+90);
    }
    for(int y = -10-(sade+10)/4; y != 10+(sade+10)/4; y++) {
      int x = sqrt(abs(-(pow(y, 2)) + pow((sade+10), 2)));
      piirrapikseli(x+156, y+90);
      piirrapikseli(x+157, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+156, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+157, y+90);
    }
    for(int y = -10-(sade+20)/4; y != 10+(sade+20)/4; y++) {
      int x = sqrt(abs(-(pow(y, 2)) + pow((sade+20), 2)));
      piirrapikseli(x+156, y+90);
      piirrapikseli(x+157, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+156, y+90);
      piirrapikseli(RUUDUNLEVEYS-x+157, y+90);
    }
  }
}

void tvkohina(int z) {
  for(int i = 0; i != 300; i++) {
    int x = rand()%35 + 179;
    int y = rand()%18 + 67;
    piirrapikseli(x, y);
  }
}

void ruutuesiin(int kountteri) {
  int kerroin = 4;
  int kount = 40-kountteri*kerroin;
  if(kountteri == 0) tyhjenna_ruutu();
  else {
    for(int r = 0; r != 200; r++) {
      for(int i = 0; i != 80; i++) {
	if(i > 40-kount and i < 40+kount) continue;
	poistatavu(i, r);
      }
    }
  }
  if(kountteri/kerroin <= 1) erikoisefekti = false;
  return;
}

void ruutupois(int kountteri) {
  int kerroin = 4;
  if(kountteri == 0) tyhjenna_ruutu();
  else {
    int kount = (40-kountteri)*kerroin;
    for(int r = 0; r != 200; r++) {
      for(int i = 0; i != 80; i++) {
	if(i < kount or i > 80-kount) poistatavu(i, r);
      }
    }
  }
  if(kountteri/kerroin <= 1) {
    erikoisefekti = false;
    tkesk = true;
  }
  return;
}

void kaikki_pois_ruudulta() {
  for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
    if((*h_iter)->toiminta != false) (*h_iter)->toiminta = false;
  }
  for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
    if((*h_iter)->ruudulla != 0) (*h_iter)->ruudulla = 0;
  }
  for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
    if((*ev_iter)->toiminta != false) (*ev_iter)->toiminta = false;
  }
  for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
    if((*ev_iter)->ruudulla != 0) (*ev_iter)->ruudulla = 0;
  }
}

//tfalku
bool tarinafunktio() {
  bool osuma = true;

  if(tarinanvaihe == 5) {
    tkesk = true;
  }
  else if(tarinanvaihe == 50) { //HKÄP-LOGO
    erikoisefekti = true;
    efektiptr = &ruutuesiin;
    glogo.x = 72;
    glogo.y = 22;
    glogo.ruudulla = 1;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 51) {
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 52) {
    erikoisefekti = true;
    efektiptr = &ruutupois;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 53) {
    glogo.ruudulla = 0;
    tyhjenna_ruutu();
    tyhjenna_vfb();
    t_ajastin = 18;
  }
  else if(tarinanvaihe == 54) {
    piirrakuva(&aveteks_bm, 84, 80, false);
    t_ajastin = 70;
  }
  else if(tarinanvaihe == 55) {
    tyhjenna_ruutu();
    tyhjenna_vfb();
    t_ajastin = 40;
  }
  
  else if(tarinanvaihe == 100) { //ALKUKUVA
    soita_musa(&teema, &teema_h);
    
    alkuteks.x = 24;
    alkuteks.y = 82;
    alkuteks.ruudulla = 4;
  
    pilvi1.x = -40;
    pilvi1.y = 40;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;

    liplap.x = 8;
    liplap.y = 150;
    liplap.toiminta = true;
    liplap.toimintakatto = 10;
    liplap.toimintaptr = &liplapfunktio;
    liplap.ruudulla = 4;

    pilvi2.x = 126;
    pilvi2.y = 20;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -30;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    aalto.toiminta = true;
    aalto.toimintakatto = 58;
    aalto.toimintaptr = &aaltofunktio;

    kasvi1.kaksivarinen = true;
    kasvi1.x = 92;
    kasvi1.y = 147;
    kasvi1.ruudulla = 2;
    kasvi1.framehidastus = 4;
    kasvi1.framekierto.push_back(0);
    kasvi1.framekierto.push_back(1);
    kasvi1.framekierto.push_back(2);
    kasvi1.framekierto.push_back(3);
    kasvi1.framekierto.push_back(2);
    kasvi1.framekierto.push_back(1);   
    kasvi1.framekierto.push_back(0);
    kasvi1.framekierto.push_back(99);
    kasvi1.framekierto.push_back(5);

    kasvi2.kaksivarinen = true;
    kasvi2.x = 72;
    kasvi2.y = 157;
    kasvi2.ruudulla = 2;
    kasvi2.framehidastus = 4;
    kasvi2.framekierto.push_back(0);
    kasvi2.framekierto.push_back(1);
    kasvi2.framekierto.push_back(2);
    kasvi2.framekierto.push_back(3);
    kasvi2.framekierto.push_back(2);
    kasvi2.framekierto.push_back(1);   
    kasvi2.framekierto.push_back(0);
    kasvi2.framekierto.push_back(99);
    kasvi2.framekierto.push_back(5);

    taustakuva = true;
    taustakuva_ptr = &maisema_bm;

    t_ajastin = 80;
  }
  else if(tarinanvaihe == 101) {
    lintu1.x = 0;
    lintu1.y = 0;
    lintu1.ruudulla = 4;
    lintu1.framekierto.push_back(0);
    lintu1.framekierto.push_back(1);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(3);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(1);   
    lintu1.framekierto.push_back(0);
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toimintaptr = &linnunrata;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 102) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 1;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 103) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 2;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 104) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 2;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 105) {
    lopeta_musa(teema_h);
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 107) {
    morteks.ruudulla = 1;
    morteks.x = 46;
    morteks.y = 40;
    t_ajastin = 60;
  }
  else if(tarinanvaihe == 108) {
    maisteks.ruudulla = 1;
    maisteks.x = 42;
    maisteks.y = 114;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 109) {
    maisteks.ruudulla = 0;
    morteks.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 200) {  //ENSIMMÄINEN KOHTAUS, KOTONA
    taustakuva = true;
    taustakuva_ptr = &huone_bm;
    ovi1.x = 82;
    ovi1.y = 60;
    ovi1.ruudulla = 4;
    prota1.x = 148;
    prota1.y = 86;
    prota1.frame = 0;
    prota1.ruudulla = 2;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 201) {
    erikoisefekti = true;
    efektiptr = &tvkohina;
    MIDASplaySample(tvkohina_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 202) {
    erikoisefekti = false;
    tvmies.ruudulla = 1;
    tvmies.x = 190;
    tvmies.y = 68;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 203) {
    prota1.frame = 15;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 204) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe1;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 205) {
    erikoisefekti = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 206) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe2;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 207) {
    erikoisefekti = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 208) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe1;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 209) {
    erikoisefekti = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 210) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe2;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 211) {
    erikoisefekti = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 212) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe1;
    MIDASplaySample(propuhe2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 213) {
    erikoisefekti = true;
    efektiptr = &puhetta;
    puheptr = &puhe2;
    MIDASplaySample(paapuhe2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 214) {
    erikoisefekti = false;
    t_ajastin = 4;
  }
  else if(tarinanvaihe == 215) {
    erikoisefekti = true;
    efektiptr = &tvkohina;
    MIDASplaySample(tvkohina_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    tvmies.ruudulla = 0;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 216) {
    erikoisefekti = false;
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 217) {

    prota1.kavelee = true;
    kavelyohje kavely1;
    prota1.aseta_flip(true);
    kavely1.x_paamaara = 82;
    kavely1.paasuunta = 4;
    kavely1.loppuframe = 6;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.paasuunta = 8;
    kavely2.y_paamaara = 82;
    kavely2.loppuframe = 6;
    kavely2.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 218) {
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 219) {
    ovi1.x = 82;
    ovi1.y = 60;
    ovi1.ruudulla = 0;

    ovi2.x = 71;
    ovi2.y = 58;
    ovi2.ruudulla = 1;

    MIDASplaySample(ovi1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 220) {
    prota1.kavelee = true;
    kavelyohje kavely3;
    kavely3.paasuunta = 8;
    kavely3.y_paamaara = 72;
    kavely3.loppuframe = 6;
    prota1.kavelyvec.push_back(kavely3);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 221) {
    prota1.ruudulla = 0;
    prota1.aseta_flip(false);
    ovi2.ruudulla = 0;
    ovi1.ruudulla = 1;

    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 222) {
    ovi1.ruudulla = 0;
    prota1.ruudulla = 0;
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 300) { //LÄHTÖ KOTITALOLTA
    taustakuva = true;
    taustakuva_ptr = &kotitalo_bm;
    liovi.x = 211;
    liovi.y = 95;
    liovi.frame = 0;
    liovi.ruudulla = 1;

    liovi.framekierto_sample = &liuovi_s;
    liovi.framekierto.push_back(99);
    liovi.framekierto.push_back(10);
    liovi.framekierto.push_back(109);
    liovi.framekierto.push_back(1);
    liovi.framekierto.push_back(2); 
    liovi.framekierto.push_back(3);
    liovi.framekierto.push_back(4);
    liovi.framekierto.push_back(5);
    liovi.framekierto.push_back(6);
    liovi.framekierto.push_back(99);
    liovi.framekierto.push_back(30);
    liovi.framekierto.push_back(109);
    liovi.framekierto.push_back(6);
    liovi.framekierto.push_back(5);
    liovi.framekierto.push_back(4);
    liovi.framekierto.push_back(3);
    liovi.framekierto.push_back(2);
    liovi.framekierto.push_back(1);
    liovi.framekierto.push_back(0);
    liovi.framekierto.push_back(99);
    liovi.framekierto.push_back(70);
    liovi.framekierto.push_back(99);
    liovi.framekierto.push_back(70);

    prota1.x = 216;
    prota1.y = 98;
    prota1.frame = 0;
    prota1.ruudulla = 2;
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 301) {
    liovi.ruudulla = 2;
    prota1.ruudulla = 1;

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 131;
    kavely1.paasuunta = 2;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.alkuframe = 13;
    kavely2.flippaa.first = 1;
    kavely2.flippaa.second = -5;
    kavely2.paasuunta = 4;
    kavely2.x_paamaara = 130;
    prota1.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.paasuunta = 1;
    kavely3.y_paamaara = 180;
    kavely3.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely3);
  }
  else if(tarinanvaihe == 302) {
    liovi.ruudulla = 0;
    prota1.ruudulla = 0;
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 303) { //METSIKKÖ
    taustakuva = true;
    taustakuva_ptr = &metsikko_bm;

    plintu.x = 126;
    plintu.y = 20;
    plintu.frame = 6;
    plintu.ruudulla = 4;

    prota1.ruudulla = 2;
    prota1.frame = 12;
    prota1.x = 294;
    prota1.y = 70;
    prota1.aseta_flip(true);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 232;
    kavely1.paasuunta = 4;
    prota1.kavelyvec.push_back(kavely1);
    kavelyohje kavely2;
    //kavely2.x_paamaara = 200;  //BUGI??? ...kun kävellään pääsuuntaan 1 ja x.paamaara on päällä?
    kavely2.y_paamaara = 116;
    kavely2.paasuunta = 1;
    kavely2.loppuframe = 14;
    kavely2.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 304) {
    paaylos.ruudulla = 1;
    paaylos.x = prota1.x+10;
    paaylos.y = prota1.y;

    t_ajastin = 30;
  }
  else if(tarinanvaihe == 305) {
    t_ajastin = 500;
    efektikountteri = 500;
    erikoisefekti = true;
    efektiptr = &linnunlaulu1;
  }
  else if(tarinanvaihe == 306) {
    drone.framekierto.push_back(0);
    drone.framekierto.push_back(1);
    
    drone.x = 85;
    drone.y = -20;
    drone.suunta = 2;
    drone.vauhti = 1;
    drone.ruudulla = 1;

    t_ajastin = 30;
  }  
  else if(tarinanvaihe == 307) {
    drone.vauhti = 0;
    t_ajastin = 200;
    efektiptr = &piipluku;
    piipptr = beep1;
    efektikountteri = 200;
    erikoisefekti = true;
  }  
  else if(tarinanvaihe == 308) {
    erikoisefekti = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 309) {
    t_ajastin = 500;
    efektikountteri = 500;
    erikoisefekti = true;
    efektiptr = &linnunlaulu2;
  }
  else if(tarinanvaihe == 310) {
    t_ajastin = 200;
    efektiptr = &piipluku;
    piipptr = beep2;
    efektikountteri = 200;
    erikoisefekti = true;
  }
  
  else if(tarinanvaihe == 311) { //RADIOMASTO
    kaikki_pois_ruudulta();
    taustakuva = true;
    taustakuva_ptr = &masto_bm;
    t_ajastin = 230;
    erikoisefekti = true;
    efektiptr = &r_aaltofunktio;

    pilvi1.x = -40;
    pilvi1.y = 50;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;

    pilvi2.x = 156;
    pilvi2.y = 20;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -10;
    pilvi3.y = 16;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;
  }
  else if(tarinanvaihe == 312) {
    erikoisefekti = false;
    taustakuva = false;
    pilvi1.ruudulla = 0;
    pilvi2.ruudulla = 0;
    pilvi3.ruudulla = 0;    
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 313) { //METSIKKÖ UUDESTAAN
    taustakuva = true;
    taustakuva_ptr = &metsikko_bm;
    drone.ruudulla = 1;
    plintu.ruudulla = 1;
    prota1.ruudulla = 2;
    paaylos.ruudulla = 1;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 314) {
    drone.framekierto.clear();
    drone.framekierto.push_back(2);
    drone.framekierto.push_back(3);
    drone.suunta = 7;
    drone.vauhti = 1;
    drone.ruudulla = 1;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 315) {
    erikoisefekti = true;
    efektiptr = &plinnunrata;
    efektikountteri = 70;
    t_ajastin = 70;
  }
  else if(tarinanvaihe == 316) {
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 124;
    kavely1.paasuunta = 4;
    prota1.kavelyvec.push_back(kavely1);
    kavelyohje kavely2;
    kavely2.paasuunta = 1;
    kavely2.y_paamaara = RUUDUNKORKEUS+10;
    kavely2.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 317) {
    kaikki_pois_ruudulta();
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 318) {
    teksvill.ruudulla = 1;
    teksvill.x = 90;
    teksvill.y = 80;
    MIDASplaySample(kaup_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 319) {
    teksvill.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 320) {   //KAUPUNKI 1
    taustakuva = true;
    taustakuva_ptr = &kaupunki1_bm;

    pilvi1.x = 124;
    pilvi1.y = 14;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;
    pilvi1.rajattu = true;
    pilvi1.rajausnelio.x = 220;
    pilvi1.rajausnelio.leveys = RUUDUNLEVEYS-220;
    pilvi1.rajausnelio.y = 0;
    pilvi1.rajausnelio.korkeus = 40;
    
    prota1.x = 282;
    prota1.y = 90;
    prota1.frame = 0;
    prota1.aseta_flip(true);
    prota1.ruudulla = 3;

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 114;
    kavely1.paasuunta = 1;
    kavely1.kliikemuutos = 100;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.alkuframe = 12;
    kavely2.paasuunta = 4;
    kavely2.x_paamaara = -20;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 130;
    prota1.kavelyvec.push_back(kavely2);

    kulkija1.x = 20;
    kulkija1.y = 126;
    kulkija1.frame = 0;
    kulkija1.ruudulla = 2;

    kulkija1.kavelee = true;
    kavelyohje kavely3;
    kavely3.x_paamaara = 330;
    kavely3.paasuunta = 6;
    kulkija1.kavelyvec.push_back(kavely3);

    t_ajastin = 30;
  }
  else if(tarinanvaihe == 322) {
    auto1.ruudulla = 1;
    auto1.x = RUUDUNLEVEYS;
    auto1.y = RUUDUNKORKEUS-auto1_bm.korkeus/2;
    auto1.suunta = 4;
    auto1.vauhti = -99;
    auto1.turbo = 10;
    t_ajastin = 50;
    MIDASplaySample(auto_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 324) {
    kulkija2.x = 0;
    kulkija2.y = 126;
    kulkija2.frame = 0;
    kulkija2.ruudulla = 2; //palauta 2

    kulkija2.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 330;
    kavely1.paasuunta = 6;
    kulkija2.kavelyvec.push_back(kavely1);
  }

  //

  else if(tarinanvaihe == 350) {
    taustakuva = false;
    pilvi1.ruudulla = 0;
    pilvi1.rajattu = false;    
    kulkija1.ruudulla = 0;
    kulkija2.ruudulla = 0;
    auto1.ruudulla = 0;
    prota1.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  
  else if(tarinanvaihe == 351) {   //KAUPUNKI 2
    taustakuva = true;
    taustakuva_ptr = &kaupunki2_bm;

    pilvi2.x = 116;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
    pilvi2.rajattu = true;
    pilvi2.rajausnelio.x = 132;
    pilvi2.rajausnelio.leveys = 248-132;
    pilvi2.rajausnelio.y = 8;
    pilvi2.rajausnelio.korkeus = 50-8;
    
    prota1.x = RUUDUNLEVEYS;
    prota1.y = 114;
    prota1.frame = 13;
    prota1.ruudulla = 3;
    prota1.aseta_flip(true);

    bovi1.x = 286;
    bovi1.y = 94;
    bovi1.ruudulla = 4;

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = -20;
    kavely1.paasuunta = 4;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    prota1.kavelyvec.push_back(kavely1);

    kulkija4.x = -20;
    kulkija4.y = 126;
    kulkija4.frame = 0;
    kulkija4.ruudulla = 1;
    
    kulkija4.kavelee = true;
    kavelyohje kavely2;
    kavely2.x_paamaara = 330;
    kavely2.paasuunta = 6;
    kulkija4.kavelyvec.push_back(kavely2);

    t_ajastin = 32;
  }
  else if(tarinanvaihe == 353) {
    potkula.ruudulla = 2;
    potkula.x = RUUDUNLEVEYS + potkula.kuva->leveys;
    potkula.y = 126;
    potkula.toiminta = true;
    potkula.toimintaptr = &potku;
    t_ajastin = 400;
  }

  else if(tarinanvaihe == 355) {
    taustakuva = false;
    pilvi2.ruudulla = 0;
    pilvi2.rajattu = false;
    prota1.ruudulla = 0;
    kulkija4.ruudulla = 0;
    potkula.ruudulla = 0;
    bovi1.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 370) {   //KAUPUNKI 3
    taustakuva = true;
    taustakuva_ptr = &kaupunki3_bm;
    prota1.x = RUUDUNLEVEYS;
    prota1.y = 142;
    prota1.frame = 13;
    prota1.ruudulla = 3;
    prota1.aseta_flip(true);

    puuosa.x = 105;
    puuosa.y = 73;
    puuosa.ruudulla = 1;

    pilvi3.x = 52;
    pilvi3.y = 12;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;
    pilvi3.rajattu = true;
    pilvi3.rajausnelio.x = 68;
    pilvi3.rajausnelio.leveys = 220-68;
    pilvi3.rajausnelio.y = 10;
    pilvi3.rajausnelio.korkeus = 34-10;
    
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = -20;
    kavely1.paasuunta = 4;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    prota1.kavelyvec.push_back(kavely1);

    kulkija5.x = 30;
    kulkija5.y = 156;
    kulkija5.frame = 0;
    kulkija5.ruudulla = 1;
    
    kulkija5.kavelee = true;
    kavelyohje kavely2;
    kavely2.x_paamaara = 330;
    kavely2.paasuunta = 6;
    kulkija5.kavelyvec.push_back(kavely2);

    t_ajastin = 80;
  }
  else if(tarinanvaihe == 372) {
    juna.x = 228;
    juna.y = 74;
    juna.ruudulla = 4;
    juna.suunta = 4;
    juna.vauhti = -99;
    juna.turbo = 2;
    juna.rajattu = true;
    juna.rajausnelio.x = 68;
    juna.rajausnelio.leveys = 224-72; 
    juna.rajausnelio.y = 64;
    juna.rajausnelio.korkeus = 90-64;
  }

  else if(tarinanvaihe == 374) {
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    puuosa.ruudulla = 0;
    pilvi3.ruudulla = 0;
    pilvi3.rajattu = false;
    juna.ruudulla = 0;
    prota1.ruudulla = 0;
    kulkija5.ruudulla = 0;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 390) {   //INSTITUUTIN PIHA
    taustakuva = true;
    taustakuva_ptr = &insttalo_bm;

    pilvi2.x = 150;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -10;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    prota1.x = RUUDUNLEVEYS;
    prota1.y = 150;
    prota1.frame = 13;
    prota1.ruudulla = 3;
    prota1.aseta_flip(true);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 200;
    kavely1.paasuunta = 4;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 7;
    prota1.kavelyvec.push_back(kavely1);
  }

  else if(tarinanvaihe == 392) {
    t_ajastin = 30;
  }

  else if(tarinanvaihe == 394) {
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    pilvi2.ruudulla = 0;
    pilvi3.ruudulla = 0;
    prota1.ruudulla = 0;
    t_ajastin = 20;
  }
  
  else if(tarinanvaihe == 396) {
    taustakuva = true;
    taustakuva_ptr = &instkylt_bm;
    soita_musa(&instf, &instf_h);
    t_ajastin = 100;
  }

  else if(tarinanvaihe == 398) {
    lopeta_musa(instf_h);
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 402) {
    taustakuva = true;
    taustakuva_ptr = &insttalo_bm;
    pilvi2.ruudulla = 4;
    pilvi3.ruudulla = 4;
    prota1.ruudulla = 3;
    t_ajastin = 30;
  }

  else if(tarinanvaihe == 404) {
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 140;
    kavely1.alkuframe = 13;
    kavely1.paasuunta = 4;
    prota1.kavelyvec.push_back(kavely1);
    kavelyohje kavely2;
    kavely2.y_paamaara = 118;
    kavely2.alkuframe = 7;
    kavely2.paasuunta = 8;
    kavely2.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely2);
  }
  
  else if(tarinanvaihe == 406) {
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    pilvi2.ruudulla = 0;
    pilvi3.ruudulla = 0;
    prota1.ruudulla = 0;
    t_ajastin = 60;
  }

  else if(tarinanvaihe == 500) {   //INSTITUUTIN KÄYTÄVÄ
    taustakuva = true;
    taustakuva_ptr = &kaytava_bm;

    prota1.x = 0;
    prota1.y = 134;
    prota1.frame = 13;
    prota1.ruudulla = 2;
    prota1.aseta_flip(false);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = RUUDUNLEVEYS+20;
    kavely1.paasuunta = 6;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    prota1.kavelyvec.push_back(kavely1);

    droidi.x = RUUDUNLEVEYS-80;
    droidi.y = 164;
    droidi.ruudulla = 1;
    droidi.suunta = 4;
    droidi.vauhti = 1;

    droidi.framekierto.push_back(0);
    droidi.framekierto.push_back(1);
    droidi.framekierto.push_back(2);
    droidi.framekierto.push_back(3);
    droidi.framekierto.push_back(4);
    droidi.framekierto.push_back(5);   
    droidi.framekierto.push_back(99);
    droidi.framekierto.push_back(5);
    droidi.framekierto.push_back(4);
    droidi.framekierto.push_back(3);
    droidi.framekierto.push_back(2);
    droidi.framekierto.push_back(1);
    droidi.framekierto.push_back(0);
    droidi.framekierto.push_back(99);
    droidi.framekierto.push_back(5);

    erikoisefekti = true;
    efektiptr = &kaytavavalot;
    efektikountteri = 300;

    aaniloop_sample = &kaytava_s;
    aaniloop_kesto = 80;
    aaniloop_kountteri = 80;
    aaniloop_kerrat = 4;
    MIDASplaySample(kaytava_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }

  else if(tarinanvaihe == 502) {
    taustakuva = false;
    erikoisefekti = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    droidi.ruudulla = 0;
    prota1.ruudulla = 0;
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 504) {
    taustakuva = true;
    taustakuva_ptr = &hissi_bm;
    erikoisefekti = true;
    efektiptr = &kaytavavalot;

    hiseina.x = 181;
    hiseina.y = 73;
    hiseina.ruudulla = 1;

    hisovi.x = 165;
    hisovi.y = 73;
    hisovi.ruudulla = 3;
    hisovi.frame = 0;
    
    prota1.x = -20;
    prota1.y = 90;
    prota1.frame = 13;
    prota1.ruudulla = 2;
    prota1.aseta_flip(false);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 146;
    kavely1.paasuunta = 6;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 14;
    prota1.kavelyvec.push_back(kavely1);

    efektikountteri = 300;
  }  

  else if(tarinanvaihe == 505) {
    erikoisefekti2 = true;
    efektiptr2 = &hovi_auki;
    t_ajastin = 20;
    MIDASplaySample(hisovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 506) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 507) {
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 180;
    kavely1.paasuunta = 6;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 508) {
    erikoisefekti2 = true;
    efektiptr2 = &hovi_kiinni;
    t_ajastin = 20;
    MIDASplaySample(hisovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 509) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 510) {
    taustakuva = false;
    erikoisefekti = false;
    prota1.ruudulla = 0;
    hisovi.ruudulla = 0;
    hiseina.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 520) {
    taustakuva = true;
    taustakuva_ptr = &ylakerta_bm;
    hilat.x = 93;
    hilat.y = 133;
    hilat.ruudulla = 1;
    thovi.x = 268;
    thovi.y = 73;
    thovi.ruudulla = 4;

    erikoisefekti = true;
    efektiptr = &kaytavavalot;
    efektikountteri = 400;

    t_ajastin = 30;
  }
  else if(tarinanvaihe == 522) {
    prota1.ruudulla = 2;
    prota1.x = 100;
    prota1.y = 138;
    prota1.frame = 14;
    erikoisefekti2 = true;
    efektiptr2 = &hinousu;
    t_ajastin = 70;
    MIDASplaySample(hissi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 524) {
    erikoisefekti2 = false;
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 272;
    kavely1.paasuunta = 6;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 6;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 528) {
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 530) {
    erikoisefekti2 = true;
    efektiptr2 = &thovi_auki;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 532) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 534) {
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 78;
    kavely1.paasuunta = 8;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 6;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 536) {
    erikoisefekti2 = true;
    thovi.ruudulla = 1;
    efektiptr2 = &thovi_kiinni;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 538) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 540) {
    taustakuva = false;
    erikoisefekti = false;
    prota1.ruudulla = 0;
    hilat.ruudulla = 0;
    hikansi.ruudulla = 0;
    thovi.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 542) {
    czteksti.ruudulla = 1;
    czteksti.x = 0;
    czteksti.y = 60;
    MIDASplaySample(auto_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 544) {
    czteksti.ruudulla = 0;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 600) {  //TIETOKONEHUONE
    taustakuva = true;
    taustakuva_ptr = &cz_bm;

    erikoisefekti = true;
    efektiptr = &vilkkuvalot;
    efektikountteri = 1000;

    cz_poyta.x = 115;
    cz_poyta.y = 118;
    cz_poyta.ruudulla = 2;
    thovi.x = 144;
    thovi.y = 82;
    thovi.ruudulla = 4;
    prota1.x = 148;
    prota1.y = 94;
    prota1.ruudulla = 3;
    prota1.frame = 0;
    profis.x = 171;
    profis.y = 140;
    profis.ruudulla = 1;

    aaniloop_sample = &cz_s;
    aaniloop_kesto = 50;
    aaniloop_kountteri = 50;
    aaniloop_kerrat = 4;
    MIDASplaySample(cz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);

    t_ajastin = 100;
  }

  else if(tarinanvaihe == 602) {
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.flippaa.first = true;
    kavely1.flippaa.second = -5;
    kavely1.alkuframe = 13;
    kavely1.x_paamaara = 86;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 130;
    kavely1.sivusuunta = 2;
    kavely1.suuntapoikkeama = 2;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.alkuframe = 1;
    kavely2.flippaa.first = false;
    kavely2.flippaa.second = 0;
    kavely2.paasuunta = 2;
    kavely2.y_paamaara = 148;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 120;
    kavely2.loppuframe = 15;
    prota1.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 604) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 606) {
    profis.ruudulla = 0;
    prof.ruudulla = 1;
    prof.frame = 13;
    prof.aseta_flip(true);
    prof.x = 154;
    prof.y = 140;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 608) {
    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.alkuframe = 13;
    kavely1.x_paamaara = 126;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 110;
    kavely1.sivusuunta = 2;
    kavely1.suuntapoikkeama = 3;
    kavely1.loppuframe = 14;
    kavely1.loppuun_kesk = true;
    prof.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 610) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 612) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe3;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 614) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 616) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe4;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 618) {
    erikoisefekti2 = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 620) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe3;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 622) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 624) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe4;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 626) {
    erikoisefekti2 = false;
    t_ajastin = 30;
  }

  else if(tarinanvaihe == 628) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe3;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 630) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 632) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe4;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 634) {
    erikoisefekti2 = false;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 636) {
    prota1.kavelee = true;
    prota1.ruudulla = 1;
    prof.ruudulla = 2;
    cz_poyta.ruudulla = 3;
    kavelyohje kavely1;
    kavely1.x_paamaara = 130;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    kavely1.sivusuunta = 2;
    kavely1.suuntapoikkeama = 4;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.paasuunta = 6;
    kavely2.sivusuunta = 8;
    kavely2.suuntapoikkeama = 8;
    kavely2.x_paamaara = 200;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);

    aaniloop_sample = &cz_s;
    aaniloop_kesto = 50;
    aaniloop_kountteri = 50;
    aaniloop_kerrat = 4;
    MIDASplaySample(cz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);

    t_ajastin = 50;
  }
  else if(tarinanvaihe == 638) {
    prof.aseta_flip(false);
    prof.x += 5;
  }
  else if(tarinanvaihe == 640) {
    prota1.ruudulla = 0;
    protais.ruudulla = 1;
    protais.x = 200;
    protais.y = 153;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 642) {
    avustaja.ruudulla = 1;
    avustaja.x = RUUDUNLEVEYS+50;
    avustaja.y = 148;
    avustaja.aseta_flip(true);
    kavelyohje kavely1;
    kavely1.x_paamaara = 224;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 110;
    kavely1.loppuframe = 8;
    kavely1.loppuun_kesk = true;
    avustaja.kavelyvec.push_back(kavely1);
    avustaja.kavelee = true;
  }
  else if(tarinanvaihe == 644) {
    t_ajastin = 30;
  }

  else if(tarinanvaihe == 700) {  //PÄÄ-ZOOM
    taustakuva = false;
    erikoisefekti = false;
    protais.ruudulla = 0;
    prof.ruudulla = 0;
    avustaja.ruudulla = 0;
    cz_poyta.ruudulla = 0;
    thovi.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 702) {
    taustakuva = true;
    taustakuva_ptr = &tuolipaa_bm;
    t_ajastin = 40;
  }

  else if(tarinanvaihe == 704) {
    kasi1.ruudulla = 4;
    kasi1.x = RUUDUNLEVEYS;
    kasi1.y = 52;
    erikoisefekti = true;
    efektiptr = &kasi_liike1;
    pluga.x = 232;
    pluga.y = 62;
    plugb.x = 232;
    plugb.y = 62;
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 708) {
    plugb.ruudulla = 0;
    plugc.ruudulla = 1;
    plugc.x = 232;
    plugc.y = 62;
    kasi2.ruudulla = 2;
    kasi1.ruudulla = 3;
    kasi2.x = RUUDUNLEVEYS;
    kasi2.y = 5;
    erikoisefekti = true;
    efektiptr = &kasi_liike2;
    ilme.x = 182;
    ilme.y = 94;
    t_ajastin = 120;
  }
  else if(tarinanvaihe == 710) {
    kasi2.ruudulla = 0;
    kasi3.ruudulla = 3;
    osa.ruudulla = 4;
    osa.x = 240;
    osa.y = 67;
    kasi3.x = kasi2.x;
    kasi3.y = kasi2.y;
    erikoisefekti = true;
    efektiptr = &kasi_liike3;
  }
  else if(tarinanvaihe == 712) {
    kasi1.ruudulla = 1;
    plugb.ruudulla = 2;
    plugc.ruudulla = 0;
    erikoisefekti = true;
    efektiptr = &kasi_liike4;
  }
  else if(tarinanvaihe == 714) {
    t_ajastin = 20;
    erikoisefekti = false;
  }
  else if(tarinanvaihe == 716) {
    taustakuva = false;
    kasi1.ruudulla = 0;
    kasi3.ruudulla = 0;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 750) {  //TIETOKONEHUONE OSA 2
    taustakuva = true;
    taustakuva_ptr = &cz_bm;

    erikoisefekti = true;
    efektiptr = &vilkkuvalot;
    efektikountteri = 1000;

    cz_poyta.x = 115;
    cz_poyta.y = 118;
    cz_poyta.ruudulla = 2;
    thovi.x = 144;
    thovi.y = 82;
    thovi.ruudulla = 4;

    protais.ruudulla = 1;
    protais.x = 200;
    protais.y = 153;
    
    prof.x = 136;
    prof.y = 144;
    prof.frame = 13;
    prof.ruudulla = 2;
    prof.aseta_flip(false);

    avustaja.ruudulla = 1;
    avustaja.x = 224;
    avustaja.y = 148;
    avustaja.aseta_flip(true);

    t_ajastin = 20;
  }
  else if(tarinanvaihe == 752) {
    protais.ruudulla = 0;
    prota1.ruudulla = 1;
    prota1.x = 186;
    prota1.y = 153;
    prota1.frame = 14;
    prota1.aseta_flip(true);
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 754) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe5;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 756) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 758) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe6;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 760) {
    erikoisefekti2 = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 762) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe5;
    MIDASplaySample(propuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 764) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 766) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe6;
    MIDASplaySample(paapuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 768) {
    erikoisefekti2 = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 770) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe5;
    MIDASplaySample(propuhe2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 772) {
    erikoisefekti2 = true;
    efektiptr2 = &puhetta;
    puheptr = &puhe6;
    MIDASplaySample(paapuhe2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 774) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 776) {
    prota1.kavelee = true;

    kavelyohje kavely1;
    kavely1.paasuunta = 4;
    kavely1.x_paamaara = 102;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.alkuframe = 6;
    kavely2.paasuunta = 7;
    kavely2.x_paamaara = 85;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.flippaa.first = false;
    kavely3.alkuframe = 12;
    kavely3.paasuunta = 6;
    kavely3.y_paamaara = 120;
    kavely3.kliikemuutos = 110;
    kavely3.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely3);

    aaniloop_sample = &cz_s;
    aaniloop_kesto = 50;
    aaniloop_kountteri = 50;
    aaniloop_kerrat = 2;
    MIDASplaySample(cz_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 778) {
    prof.ruudulla = 1;
    cz_poyta.ruudulla = 2;
    prota1.ruudulla = 3;
    
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.flippaa.first = false;
    kavely1.alkuframe = 12;
    kavely1.paasuunta = 9;
    kavely1.sivusuunta = 6;
    kavely1.suuntapoikkeama = 2;
    kavely1.x_paamaara = 148;
    kavely1.kliikemuutos = 90;
    kavely1.loppuframe = 6;
    kavely1.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 780) {
    t_ajastin = 20;
  }
    else if(tarinanvaihe == 782) {
    erikoisefekti2 = true;
    efektiptr2 = &thovi_auki;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 784) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 786) {
    thovi.ruudulla = 3;
    prota1.ruudulla = 4;
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 86;
    kavely1.paasuunta = 8;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 6;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 788) {
    erikoisefekti2 = true;
    efektiptr2 = &thovi_kiinni;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 790) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 792) {
    taustakuva = false;
    erikoisefekti = false;

    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 800) {   //INSTITUUTIN PIHA (2. kerta)
    taustakuva = true;
    taustakuva_ptr = &insttalo_bm;

    pilvi2.x = 150;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -10;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    prota1.x = 148;
    prota1.y = 126;
    prota1.frame = 1;
    prota1.ruudulla = 3;
    prota1.aseta_flip(false);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 145;
    kavely1.paasuunta = 2;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.x_paamaara = 248;
    kavely2.paasuunta = 6;
    kavely2.alkuframe = 12;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 802) {
    taustakuva = false;
    erikoisefekti = false;

    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();

    t_ajastin = 10;
  }
  else if(tarinanvaihe == 804) { //KAUPUNKI 2, 2. kerta
    taustakuva = true;
    taustakuva_ptr = &kaupunki2_bm;

    pilvi2.x = 116;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
    pilvi2.rajattu = true;
    pilvi2.rajausnelio.x = 132;
    pilvi2.rajausnelio.leveys = 248-132;
    pilvi2.rajausnelio.y = 8;
    pilvi2.rajausnelio.korkeus = 50-8;
    
    prota1.x = 44;
    prota1.y = 125;
    prota1.frame = 13;
    prota1.ruudulla = 3;
    prota1.aseta_flip(false);

    bovi1.x = 286;
    bovi1.y = 94;
    bovi1.ruudulla = 4;

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 156;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.y_paamaara = 92;
    kavely2.paasuunta = 8;
    kavely2.alkuframe = 6;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);
  }

  else if(tarinanvaihe == 806) {
    taustakuva = false;
    pilvi2.rajattu = false;

    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();

    t_ajastin = 20;
  }
  else if(tarinanvaihe == 808) {
    textparc.ruudulla = 1;
    textparc.x = 120;
    textparc.y = 78;
    soita_musa(&parcf, &parcf_h);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 810) {
    taustakuva = false;
    textparc.ruudulla = 0;
    lopeta_musa(parcf_h);
    t_ajastin = 10;
  }
  
  else if(tarinanvaihe == 820) {  //PUISTO
    taustakuva = true;
    taustakuva_ptr = &puisto_bm;
    
    prota1.x = 94;
    prota1.y = RUUDUNKORKEUS;
    prota1.ruudulla = 1;
    prota1.frame = 6;
    prota1.aseta_flip(true);

    kulkija3.ruudulla = 1;
    kulkija3.x = 130;
    kulkija3.y = 104;

    kulkija3.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = RUUDUNLEVEYS;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    kulkija3.kavelyvec.push_back(kavely1);
    
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 822) {

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 118;
    kavely1.paasuunta = 8;
    kavely1.kliikemuutos = 110;
    kavely1.sivusuunta = 6;
    kavely1.suuntapoikkeama = 2;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.y_paamaara = 104;
    kavely2.paasuunta = 7;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.x_paamaara = -24;
    kavely3.paasuunta = 4;
    kavely3.alkuframe = 12;
    kavely3.loppuun_kesk = true;    
    prota1.kavelyvec.push_back(kavely3);
  }
  else if(tarinanvaihe == 824) {
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 826) {  //PUISTO2
    taustakuva = true;
    taustakuva_ptr = &puisto2_bm;

    prota1.x = RUUDUNLEVEYS + prota1.arkki_w;
    prota1.y = 128;
    prota1.ruudulla = 1;
    prota1.frame = 12;
    prota1.aseta_flip(true);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 116;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.x_paamaara = 98;
    kavely2.paasuunta = 7;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.y_paamaara = 94;
    kavely3.paasuunta = 8;
    kavely3.alkuframe = 6;
    kavely3.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely3);

    kavelyohje kavely4;
    kavely4.x_paamaara = -(prota1.arkki_w);
    kavely4.paasuunta = 4;
    kavely4.alkuframe = 12;
    kavely4.kliikemuutos = 110;
    kavely4.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely4);
  }
  else if(tarinanvaihe == 824) {
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }

  else if(tarinanvaihe == 828) {  //RANTA
    taustakuva = true;
    taustakuva_ptr = &ranta_bm;

    pilvi1.x = -40;
    pilvi1.y = 40;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;

    pilvi2.x = 126;
    pilvi2.y = 20;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -30;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;
    
    prota1.x = RUUDUNLEVEYS + prota1.arkki_w;
    prota1.y = 138;
    prota1.ruudulla = 0;
    prota1.frame = 12;
    prota1.aseta_flip(true);

    lintu2.ruudulla = 1;
    lintu2.x = 91;
    lintu2.y = 153;
    
    erikoisefekti = true;
    efektiptr = &aaltofunktio2;
    efektikountteri = 10000;

    soita_musa(&ranta, &ranta_h);
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 830) {

    prota1.ruudulla = 1;
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 266;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 110;
    kavely1.loppuframe = 14;
    prota1.kavelyvec.push_back(kavely1);

    t_ajastin = 100;
  }
  else if(tarinanvaihe == 832) {
    lopeta_musa(ranta_h);
    erikoisefekti = false;
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 2;
  }
  else if(tarinanvaihe == 834) {
    taustakuva = true;
    taustakuva_ptr = &isolintu_bm;

    nokka.x = 153;
    nokka.y = 78;
    nokka.ruudulla = 1;

    nokka.framehidastus = 2;
    nokka.framekierto.push_back(99);
    nokka.framekierto.push_back(10);
    nokka.framekierto.push_back(0);
    nokka.framekierto.push_back(1);
    nokka.framekierto.push_back(2);
    nokka.framekierto.push_back(1);
    nokka.framekierto.push_back(0);
    nokka.framekierto.push_back(1);   
    nokka.framekierto.push_back(2);
    nokka.framekierto.push_back(1);
    nokka.framekierto.push_back(0);
    nokka.framekierto.push_back(1);   
    nokka.framekierto.push_back(2);
    nokka.framekierto.push_back(1);
    nokka.framekierto.push_back(0);
    nokka.framekierto.push_back(99);
    nokka.framekierto.push_back(50);
    
    t_ajastin = 26;
  }

  else if(tarinanvaihe == 835) {
    MIDASplaySample(ankpuhe1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }

  else if(tarinanvaihe == 836) {
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 2;
  }

  else if(tarinanvaihe == 838) {
    taustakuva = true;
    taustakuva_ptr = &ranta_bm;

    pilvi1.ruudulla = 4;
    pilvi2.ruudulla = 4;
    pilvi3.ruudulla = 4;
    prota1.ruudulla = 1;
    lintu2.ruudulla = 1;
    
    erikoisefekti = true;
    efektiptr = &aaltofunktio2;
    efektikountteri = 10000;
    
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 840) {
    lintu1.framekierto.clear();
    lintu1.framekierto.push_back(0);
    lintu1.framekierto.push_back(1);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(3);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(1);   
    lintu1.framekierto.push_back(0);
    lintu1.x = 0;
    lintu1.y = 0;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toimintaptr = &linnunrata;
    lintu1.toim_arg = 1;
    lintu1.ruudulla = 4;
    t_ajastin = 100;

    erikoisefekti2 = true;
    efektiptr2 = &ampuminen;
  }

  else if(tarinanvaihe == 842) {
    lintu1.toiminta = true;
    lintu1.ruudulla = 4;
    t_ajastin = 100;

    kavelyohje kavely1;
    kavely1.x_paamaara = RUUDUNLEVEYS + prota1.arkki_w;;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    erikoisefekti2 = true;
    efektiptr2 = &ampuminen2;
  }
  else if(tarinanvaihe == 844) {
    t_ajastin = 100;
    erikoisefekti2 = true;
    efektiptr2 = &ampuminen3;
  }

  else if(tarinanvaihe == 846) {
    taustakuva = false;
    erikoisefekti = false;
    erikoisefekti2 = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 848) {  //PUISTO2, UUDESTAAN
    taustakuva = true;
    taustakuva_ptr = &puisto2_bm;
    
    prota1.x = -(prota1.arkki_w);
    prota1.y = 94;
    prota1.ruudulla = 1;
    prota1.frame = 12;
    prota1.aseta_flip(false);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 107;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.y_paamaara = 64;
    kavely2.paasuunta = 8;
    kavely2.alkuframe = 6;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 110;
    prota1.kavelyvec.push_back(kavely2);

  }
  else if(tarinanvaihe == 850) {
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 900) {
    textperi.ruudulla = 1;
    textperi.x = 90;
    textperi.y = 58;
    soita_musa(&perif, &perif_h);
    t_ajastin = 50;
  }
  else if(tarinanvaihe == 904) {
    lopeta_musa(perif_h);
    taustakuva = false;
    textperi.ruudulla = 0;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 906) {   //KAUPUNGIN LAITA 1
    taustakuva = true;
    taustakuva_ptr = &peri1_bm;

    pilvi3.x = 0;
    pilvi3.y = -4;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    pilvi2.x = 176;
    pilvi2.y = -10;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;

    prota1.ruudulla = 1;
    prota1.x = 78;
    prota1.y = RUUDUNKORKEUS;
    prota1.aseta_flip(false);
    
    kulkija6.ruudulla = 2;
    kulkija6.x = 254;
    kulkija6.y = 132;
    kulkija6.aseta_flip(true);

    koira.ruudulla = 2;
    koira.x = 276;
    koira.y = 150;
    koira.aseta_flip(true);

    kulkija6.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = -30;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 110;
    kulkija6.kavelyvec.push_back(kavely1);

    koira.kavelee = true;
    kavelyohje kavely2;
    kavely2.x_paamaara = -30;
    kavely2.paasuunta = 4;
    kavely2.kliikemuutos = 110;
    koira.kavelyvec.push_back(kavely2);

    prota1.kavelee = true;
    kavelyohje kavely3;
    kavely3.x_paamaara = 118;
    kavely3.paasuunta = 9;
    kavely3.kliikemuutos = 60;
    kavely3.alkuframe = 6;
    kavely3.sivusuunta = 8;
    kavely3.suuntapoikkeama = 2;
    prota1.kavelyvec.push_back(kavely3);

    kavelyohje kavely4;
    kavely4.x_paamaara = RUUDUNLEVEYS;
    kavely4.paasuunta = 6;
    kavely4.alkuframe = 12;
    kavely4.kliikemuutos = 110;
    kavely4.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely4);
  }
  else if(tarinanvaihe == 908) {
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 910) {   //KAUPUNGIN LAITA 2
    taustakuva = true;
    taustakuva_ptr = &peri2_bm;

    prota1.ruudulla = 1;
    prota1.x = -30;
    prota1.y = 130;
    prota1.aseta_flip(false);
    
    erikoisefekti = true;
    efektiptr = &puhetta2;
    
    keinu.ruudulla = 1;
    keinu.x = 274;
    keinu.y = 74;
    keinu.framekierto.push_back(0);
    keinu.framekierto.push_back(1);
    keinu.framekierto.push_back(2);
    keinu.framekierto.push_back(3);
    keinu.framekierto.push_back(4);
    keinu.framekierto.push_back(3);
    keinu.framekierto.push_back(2);
    keinu.framekierto.push_back(1);

    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 70;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    kavely1.alkuframe = 12;
    prota1.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.y_paamaara = 44;
    kavely2.paasuunta = 8;
    kavely2.alkuframe = 6;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 90;
    kavely2.sivusuunta = 6;
    kavely2.suuntapoikkeama = 2;
    prota1.kavelyvec.push_back(kavely2);

    t_ajastin = 200;
  }

  else if(tarinanvaihe == 912) {
    taustakuva = false;
    erikoisefekti = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 914) {   //KAUPUNGIN LAITA 3
    taustakuva = true;
    taustakuva_ptr = &peri3_bm;

    prota1.ruudulla = 1;
    prota1.x = 32;
    prota1.y = RUUDUNKORKEUS;
    prota1.aseta_flip(false);
    
    prota1.kavelee = true;
    kavelyohje kavely1;
    kavely1.alkuframe = 6;
    kavely1.x_paamaara = 90;
    kavely1.paasuunta = 9;
    kavely1.kliikemuutos = 40;
    kavely1.sivusuunta = 8;
    kavely1.suuntapoikkeama = 1;
    kavely1.loppuframe = 6;
    kavely1.loppuun_kesk = true;
    prota1.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 916) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 918) {
    plintu.ruudulla = 1;
    plintu.x = 130;
    plintu.y = -20;
    plintu.suunta = 0;
    plintu.vauhti = 0;

    erikoisefekti = true;
    efektiptr = &plinnunrata2;
    efektikountteri = 70;
    t_ajastin = 70;
  }
  else if(tarinanvaihe == 920) {
    t_ajastin = 500;
    efektikountteri = 500;
    erikoisefekti = true;
    efektiptr = &linnunlaulu1;
  }
  else if(tarinanvaihe == 922) {
    erikoisefekti = false;

    drone.framekierto.clear();
    drone.framekierto.push_back(0);
    drone.framekierto.push_back(1);
    
    drone.x = 95;
    drone.y = -20;
    drone.suunta = 2;
    drone.vauhti = 1;
    drone.ruudulla = 1;

    t_ajastin = 30;
  }
  else if(tarinanvaihe == 924) {
    drone.vauhti = 0;
    efektiptr = &piipluku;
    piipptr = beep3;
    efektikountteri = 200;
    erikoisefekti = true;
    t_ajastin = 200;
  }  
  else if(tarinanvaihe == 926) {
    erikoisefekti = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 928) {
    t_ajastin = 500;
    efektikountteri = 500;
    erikoisefekti = true;
    efektiptr = &linnunlaulu2;
  }
  else if(tarinanvaihe == 930) {
    t_ajastin = 200;
    efektiptr = &piipluku;
    piipptr = beep4;
    efektikountteri = 200;
    erikoisefekti = true;
  }
  else if(tarinanvaihe == 932) {
    erikoisefekti = false;
    t_ajastin = 50;
  }
  else if(tarinanvaihe == 934) { //RADIOMASTO UUDESTAAN
    kaikki_pois_ruudulta();
    taustakuva = true;
    taustakuva_ptr = &masto_bm;
    t_ajastin = 230; //tällä on yhteys aaltofunktion arvoon
    erikoisefekti = true;
    efektiptr = &r_aaltofunktio;

    pilvi1.x = -40;
    pilvi1.y = 50;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;

    pilvi2.x = 156;
    pilvi2.y = 20;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -10;
    pilvi3.y = 16;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;
  }
  else if(tarinanvaihe == 936) {
    erikoisefekti = false;
    taustakuva = false;
    pilvi1.ruudulla = 0;
    pilvi2.ruudulla = 0;
    pilvi3.ruudulla = 0;    
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 938) {  //KAUPUNGIN LAITA 3 UUDESTAAN 
    taustakuva = true;
    taustakuva_ptr = &peri3_bm;

    prota2.ruudulla = 1;
    prota2.frame = 1;
    prota2.x = 91;
    prota2.y = 82;
    prota2.frame = 0;
    
    plintu.ruudulla = 1;
    plintu.x = 130;
    plintu.y = 20;
    plintu.frame = 6;
    plintu.aseta_flip(true);
    
    drone.ruudulla = 1;
    drone.x = 95;
    drone.y = 10;
    drone.frame = 0;

    erikoisefekti = false;

    t_ajastin = 70;
  }
  else if(tarinanvaihe == 942) {

    prota2.framehidastus = 3;
    prota2.framekierto.push_back(0);
    prota2.framekierto.push_back(1);
    prota2.framekierto.push_back(2);
    prota2.framekierto.push_back(3);
    prota2.framekierto.push_back(4);
    prota2.framekierto.push_back(5);
    prota2.framekierto.push_back(6);
    prota2.framekierto.push_back(99);
    prota2.framekierto.push_back(98);

    t_ajastin = 40;
  }
  else if(tarinanvaihe == 944) {
    prota2.framekierto.clear();
    erikoisefekti = true;
    efektiptr = &tarina;
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 946) {
    erikoisefekti = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 948) {
    prota2.ruudulla = 0;
    prota3.ruudulla = 1;
    prota3.x = prota2.x;
    prota3.y = prota2.y;

    prota3.framehidastus = 3;
    prota3.framekierto.push_back(0);
    prota3.framekierto.push_back(1);
    prota3.framekierto.push_back(2);
    prota3.framekierto.push_back(3);
    prota3.framekierto.push_back(4);
    prota3.framekierto.push_back(99);
    prota3.framekierto.push_back(98);

    t_ajastin = 40;
    MIDASplaySample(kaatuu_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 949) {
    KAIKKI_POIS;
    prota3.framekierto.clear();
    prota3.frame = 4;
    piirrakuva(&paauli_bm, 0, 0, false);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 950) {
    taustakuva = false;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 952) {
    taustakuva = true;
    taustakuva_ptr = &aivot_bm;

    aivobzz.ruudulla = 1;
    aivobzz.x = 179;
    aivobzz.y = 50;
    erikoisefekti = true;
    efektiptr = &bzz;

    t_ajastin = 140;
  }

  else if(tarinanvaihe == 954) {
    PIIRRA_KAIKKI;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 956) {
    erikoisefekti = true;
    MIDASplaySample(g_aani_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    efektiptr = &viivat;
    efektikountteri = 100;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 957) {
    erikoisefekti = false;
    taustakuva = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    kaikki_pois_ruudulta();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 958) {
    erikoisefekti = true;
    efektiptr = &defai;
    t_ajastin = 140;
  }
  else if(tarinanvaihe == 960) {
    erikoisefekti = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 961) {
    erikoisefekti = true;
    eegtaulu.x = 66;
    eegtaulu.y = 40;
    eegtaulu.ruudulla = 1;
    eeg.lapinak = true;
    eegtaulu.lapinak = true;
    eeg.ruudulla = 4;
    eegpeite.ruudulla = 3;
    eeg.x = eegtaulu.x+2;
    eeg.y = eegtaulu.y+26;
    eegpeite.x = eegtaulu.x+2;
    eegpeite.y = eegtaulu.y+26;
    efektiptr = &eegeff;
    efektikountteri = 156;
    t_ajastin = 156;
  }
  else if(tarinanvaihe == 962) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 963) {
    piirrakuva(&paauli_bm, 0, 0, false);
    MIDASplaySample(uli1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 964) {
    tyhjenna_ruutu();
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 965) {
    PIIRRA_KAIKKI;
    erikoisefekti = true;
    MIDASplaySample(g_aani_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    efektiptr = &viivat2;
    efektikountteri = 100;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 966) {
    KAIKKI_POIS;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 968) {
    error.x = 26;
    error.y = 74;
    error.ruudulla = 1;
    error.lapinak = true;
    MIDASplaySample(error_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 970) {
    MIDASplaySample(error_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 972) {
    error.ruudulla = 0;
    tyhjenna_ruutu();
    tyhjenna_vfb();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 974) {
    tyhjenna_ruutu();
    tyhjenna_vfb();
    PIIRRA_KAIKKI;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 980) {
    MIDASplaySample(g_aani2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    ascii1.x = 0;
    ascii1.y = 20;
    ascii1.ruudulla = 1;
    piirrakuva(&ascii1_bm, 0, 20, false);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 982) {
    ascii2.x = 108;
    ascii2.y = 72;
    ascii2.ruudulla = 1;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 984) {
    ascii3.x = 0;
    ascii3.y = 122;
    ascii3.ruudulla = 1;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 986) {
    ascii4.x = 132;
    ascii4.y = 156;
    ascii4.ruudulla = 1;
    piirrakuva(&ascii4_bm, 132, 156, false);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 988) {
    KAIKKI_POIS;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 990) {
    piirrakuva(&pommit_bm, 16, 22, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 992) {
    piirrakuva(&pommit_bm, 160, 70, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 994) {
    piirrakuva(&pommit_bm, 62, 124, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 996) {
    piirrakuva(&pommit_bm, 180, 170, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 998) {
    piirrakuva(&pommit_bm, 136, 30, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1000) {
    piirrakuva(&pommit_bm, 40, 90, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1002) {
    piirrakuva(&pommit_bm, 230, 130, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1004) {
    piirrakuva(&pommit_bm, 80, 180, false);
    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1006) {
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1008) {
    erikoisefekti = true;
    efektiptr = &bzz2;
    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1010) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1012) {
    piirrakuva(&paauli_bm, 0, 0, false);
    MIDASplaySample(uli2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1014) {
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1016) {
    PIIRRA_KAIKKI;
    t_ajastin = 40;
    MIDASplaySample(g_aani2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 1018) {
    taustakuva_ptr = &perig_bm;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1020) {
    KAIKKI_POIS;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1022) {
    erikoisefekti = true;
    efektiptr = &defai;
    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1024) {
    erikoisefekti = false;
    PIIRRA_KAIKKI;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1026) {
    taustakuva = false;
    t_ajastin = 36;
    efektikountteri = 36;
    erikoisefekti = true;
    efektiptr = &kaatuu;
  }
  else if(tarinanvaihe == 1028) {
    erikoisefekti = false;
    t_ajastin = 100;
    drone.ruudulla = 0;
    prota3.ruudulla = 0;
    plintu.ruudulla = 0;
  }

  else if(tarinanvaihe == 1100) {
    KAIKKI_POIS;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1102) {
    piirrakuva(&textmitt_bm, 100, 83, false);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1104) {
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 1106) {  //TIETOKONEHUONE OSA 3
    taustakuva = true;
    taustakuva_ptr = &cz_bm;

    erikoisefekti = true;
    efektiptr = &vilkkuvalot;
    efektikountteri = 1000;
    init_rivit();

    cz_poyta.x = 115;
    cz_poyta.y = 118;
    cz_poyta.ruudulla = 2;
    thovi.x = 144;
    thovi.y = 82;
    thovi.ruudulla = 4;

    prof.x = 102;
    prof.y = 153;
    prof.frame = 13;
    prof.ruudulla = 2;
    prof.aseta_flip(false);

    t_ajastin = 300;

    soita_musa(&seko, &seko_h);
  }
  else if(tarinanvaihe == 1108) {
    prof.kavelee = true;

    kavelyohje kavely1;
    kavely1.paasuunta = 4;
    kavely1.x_paamaara = 102;
    kavely1.kliikemuutos = 70;
    prof.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.alkuframe = 6;
    kavely2.paasuunta = 7;
    kavely2.x_paamaara = 85;
    kavely2.kliikemuutos = 70;
    prof.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.flippaa.first = false;
    kavely3.alkuframe = 12;
    kavely3.paasuunta = 6;
    kavely3.y_paamaara = 120;
    kavely3.kliikemuutos = 50;
    kavely3.loppuun_kesk = true;
    prof.kavelyvec.push_back(kavely3);

  }
  else if(tarinanvaihe == 1110) {
    cz_poyta.ruudulla = 2;
    prof.ruudulla = 3;
    
    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.flippaa.first = false;
    kavely1.alkuframe = 12;
    kavely1.paasuunta = 9;
    kavely1.sivusuunta = 6;
    kavely1.suuntapoikkeama = 2;
    kavely1.x_paamaara = 148;
    kavely1.kliikemuutos = 60;
    kavely1.loppuframe = 6;
    kavely1.loppuun_kesk = true;
    prof.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 1112) {
    lopeta_musa(seko_h);
    t_ajastin = 20;
  }
    else if(tarinanvaihe == 1114) {
    erikoisefekti2 = true;
    efektiptr2 = &thovi_auki;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 1116) {
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1118) {
    thovi.ruudulla = 3;
    prof.ruudulla = 4;
    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 86;
    kavely1.paasuunta = 8;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 6;
    prof.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 1120) {
    erikoisefekti2 = true;
    efektiptr2 = &thovi_kiinni;
    t_ajastin = 20;
    MIDASplaySample(erovi_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
  }
  else if(tarinanvaihe == 1121) {
    erikoisefekti2 = false;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1122) {
    taustakuva = false;
    
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();

    erikoisefekti = false;
    erikoisefekti2 = false;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1124) {   //INSTITUUTIN PIHA (3. kerta)
    taustakuva = true;
    taustakuva_ptr = &insttalo_bm;

    pilvi2.x = 150;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
  
    pilvi3.x = -10;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    prof.x = 148;
    prof.y = 126;
    prof.frame = 1;
    prof.ruudulla = 3;
    prof.aseta_flip(false);

    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 145;
    kavely1.paasuunta = 2;
    kavely1.kliikemuutos = 110;
    prof.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.x_paamaara = 278;
    kavely2.paasuunta = 6;
    kavely2.alkuframe = 12;
    kavely2.loppuun_kesk = true;
    kavely2.kliikemuutos = 90;
    prof.kavelyvec.push_back(kavely2);
  }
  else if(tarinanvaihe == 1126) {
    taustakuva = false;
    erikoisefekti = false;

    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();

    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1128) { //KAUPUNKI 2, 3. kerta
    taustakuva = true;
    taustakuva_ptr = &kaupunki2_bm;

    pilvi2.x = 116;
    pilvi2.y = 12;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
    pilvi2.rajattu = true;
    pilvi2.rajausnelio.x = 132;
    pilvi2.rajausnelio.leveys = 248-132;
    pilvi2.rajausnelio.y = 8;
    pilvi2.rajausnelio.korkeus = 50-8;
    
    prof.x = 44;
    prof.y = 115;
    prof.frame = 13;
    prof.ruudulla = 3;
    prof.aseta_flip(false);

    bovi1.x = 286;
    bovi1.y = 94;
    bovi1.ruudulla = 4;

    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 292;
    kavely1.paasuunta = 6;
    kavely1.kliikemuutos = 110;
    kavely1.loppuframe = 6;
    kavely1.loppuun_kesk = true;
    prof.kavelyvec.push_back(kavely1);

    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1130) {
    auto1.ruudulla = 1;
    auto1.x = RUUDUNLEVEYS;
    auto1.y = RUUDUNKORKEUS-auto1_bm.korkeus/2;
    auto1.suunta = 4;
    auto1.vauhti = -99;
    auto1.turbo = 10;
    MIDASplaySample(auto_s, MIDAS_CHANNEL_AUTO, 0, 11025, 64, 1);
  }
  else if(tarinanvaihe == 1132) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1134) {
    bovi1.ruudulla = 0;
    bovi2.ruudulla = 4;
    bovi2.x = 267;
    bovi2.y = 94;
    MIDASplaySample(ovi1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1136) {
    prof.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = 102;
    kavely1.paasuunta = 8;
    kavely1.loppuun_kesk = true;
    kavely1.kliikemuutos = 130;
    kavely1.loppuframe = 6;
    prof.kavelyvec.push_back(kavely1);
  }
  else if(tarinanvaihe == 1138) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1140) {
    bovi2.ruudulla = 0;
    prof.ruudulla = 0;
    bovi1.ruudulla = 4;
    MIDASplaySample(ovi2_s, 0, 100, 11025, 64, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1142) {
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1144) {
    taustakuva = true;
    taustakuva_ptr = &baari_bm;
    erikoisefekti = true;
    efektiptr = &puhetta3;
    soita_musa(&baarimusa, &baarimusa_h);
    t_ajastin = 400;
  }
  else if(tarinanvaihe == 1146) {
    lopeta_musa(baarimusa_h);
    taustakuva = false;
    erikoisefekti = false;
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1148) {
    piirrakuva(&texdrama_bm, 80, 66, false);
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 1150) {
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1152) {
    PIIRRA_KAIKKI;
    drone.framekierto.clear();
    drone.framekierto.push_back(0);
    drone.framekierto.push_back(1);
    t_ajastin = 50;
  }
  else if(tarinanvaihe == 1153) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1154) {
    taustakuva = true;
    taustakuva_ptr = &aivot_bm;

    aivobzz.ruudulla = 1;
    aivobzz.x = 179;
    aivobzz.y = 50;
    erikoisefekti = true;
    efektiptr = &bzz;

    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1156) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1158) {
    piirrakuva(&paauli_bm, 0, 0, false);
    MIDASplaySample(uli1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1159) {
    PIIRRA_KAIKKI;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1160) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1161) {
    taustakuva = true;
    taustakuva_ptr = &mittari_bm;
    efektiptr = &mittari;
    erikoisefekti = true;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 1162) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1164) {
    taustakuva = true;
    taustakuva_ptr = &aivot_bm;
    erikoisefekti = true;
    efektiptr = &bzz2;
    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1166) {
    tyhjenna_vfb();
    tyhjenna_ruutu();
    erikoisefekti = false;
    taustakuva = false;
    t_ajastin = 10;
  }
  else if(tarinanvaihe == 1168) {
    piirrakuva(&paauli_bm, 0, 0, false);
    MIDASplaySample(uli2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1170) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1172) {
    PIIRRA_KAIKKI;
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1174) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1300) {
    erikoisefekti = true;
    efektiptr = &auto2;
    t_ajastin = 70;
    soita_musa(&ambu, &ambu_h);
  }
  else if(tarinanvaihe == 1302) {
    erikoisefekti = false;
    tyhjenna_ruutu();
    tyhjenna_vfb();
    lopeta_musa(ambu_h);
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1304) {
    PIIRRA_KAIKKI;
    t_ajastin = 40;
    drone.framekierto.clear();
    drone.framekierto.push_back(0);
    drone.framekierto.push_back(1);
  }
  else if(tarinanvaihe == 1306) {
    ambu2.y = 82;
    ambu2.x = RUUDUNLEVEYS;
    ambu2.ruudulla = 2;
    erikoisefekti = true;
    efektiptr = &ambuliike1;
    t_ajastin = 120;
  }
  else if(tarinanvaihe == 1307) {
    erikoisefekti = false;
    erikoisefekti2 = true;
    efektiptr2 = &ampuminen4;
    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1308) {
    drone.framekierto.clear();
    drone.framekierto.push_back(2);
    drone.framekierto.push_back(3);
    drone.suunta = 7;
    drone.vauhti = 1;
    drone.ruudulla = 1;
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 1310) {
    drone.ruudulla = 0;
    erikoisefekti2 = false;
    ambu2.rajattu = true;
    ambu2.rajausnelio.x = 204+10;
    ambu2.rajausnelio.y = 82;
    ambu2.rajausnelio.leveys = 120-10;
    ambu2.rajausnelio.korkeus = 72;
    
    amovi.x = ambu2.x-11;
    amovi.y = ambu2.y;
    amovi.ruudulla = 4;

    MIDASplaySample(ovi1_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
    t_ajastin = 30;
  }
  else if(tarinanvaihe == 1312) {
    ambuh.x = ambu2.x + 12;
    ambuh.y = ambu2.y + 18;
    ambuh.ruudulla = 3;
    prota3.ruudulla = 4;

    ambuh.kavelee = true;
    kavelyohje kavely1;
    kavely1.x_paamaara = 106;
    kavely1.paasuunta = 4;
    kavely1.kliikemuutos = 130;
    ambuh.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.x_paamaara = 83;
    kavely2.paasuunta = 7;
    kavely2.kliikemuutos = 130;
    ambuh.kavelyvec.push_back(kavely2);

    kavelyohje kavely3;
    kavely3.y_paamaara = 77;
    kavely3.paasuunta = 8;
    kavely3.loppuun_kesk = true;
    kavely3.kliikemuutos = 130;
    kavely3.loppuframe = 2;
    ambuh.kavelyvec.push_back(kavely3);
      
  }
  else if(tarinanvaihe == 1314) {
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1316) {
    t_ajastin = 20;
    ambuh.frame = 4;
  }
  else if(tarinanvaihe == 1318) {
    t_ajastin = 20;
    ambuh.frame = 0;

    prota4.ruudulla = 4;
    prota4.x = ambuh.x + 12;
    prota4.y = ambuh.y + 16;
    prota3.ruudulla = 0;
    erikoisefekti = true;
    efektiptr = &kanto;

    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1320) {

    ambuh.kavelee = true;
    kavelyohje kavely1;
    kavely1.y_paamaara = ambu2.y + 18;
    kavely1.paasuunta = 2;
    kavely1.kliikemuutos = 130;
    ambuh.kavelyvec.push_back(kavely1);

    kavelyohje kavely2;
    kavely2.x_paamaara = ambu2.x + 12;
    kavely2.paasuunta = 6;
    kavely2.kliikemuutos = 130;
    kavely2.loppuun_kesk = true;
    ambuh.kavelyvec.push_back(kavely2);

    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1322) {
    erikoisefekti = false;

    amovi.ruudulla = 0;
    ambu2.rajattu = false;
    prota4.ruudulla = 0;
    ambuh.ruudulla = 0;

    MIDASplaySample(ovi2_s, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);

    t_ajastin = 40;
  }
  else if(tarinanvaihe == 1324) {
    erikoisefekti = true;
    efektiptr = &ambuliike2;
    t_ajastin = 140;
  }
  else if(tarinanvaihe == 1326) {
    KAIKKI_POIS;
    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1400) {
    taustakuva = true;
    taustakuva_ptr = &autotie_bm;

    pilvi1.x = -40;
    pilvi1.y = 40;
    pilvi1.suunta = 6;
    pilvi1.vauhti = 20;
    pilvi1.ruudulla = 4;

    pilvi2.x = 126;
    pilvi2.y = 20;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
    pilvi2.rajattu = false;
  
    pilvi3.x = -30;
    pilvi3.y = 6;
    pilvi3.suunta = 6;
    pilvi3.vauhti = 20;
    pilvi3.ruudulla = 4;

    puita.x = 0;
    puita.y = 90;
    puita.ruudulla = 1;

    t_ajastin = 20;
  }
  else if(tarinanvaihe == 1402) {
    ambu4.x = -30;
    erikoisefekti = true;
    efektiptr = &ambuliike3;
    efektikountteri = 40;
    t_ajastin = 40;
    MIDASplaySample(auto_s, MIDAS_CHANNEL_AUTO, 0, 11025, 64, 1);
  }
  else if(tarinanvaihe == 1404) {
    erikoisefekti = false;
    t_ajastin = 60;
  }
  else if(tarinanvaihe == 1406) {
    KAIKKI_POIS;
    t_ajastin = 6;
  }
  else if(tarinanvaihe == 1408) {
    piirrakuva(&eof_bm, 0, 0, false);
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 1410) {
    tyhjenna_ruutu();
    tyhjenna_vfb();
    t_ajastin = 70;
  }
  else if(tarinanvaihe == 1500) {  //LOPPUTEKSTIT
    soita_musa(&teema, &teema_h);

    kasvi1.framekierto.clear();
    kasvi2.framekierto.clear();
    lintu1.framekierto.clear();

    lopputeks.x = 8;
    lopputeks.y = 106;
    lopputeks.rajattu = true;
    lopputeks.rajausnelio.x = 8;
    lopputeks.rajausnelio.leveys = 180;
    lopputeks.rajausnelio.y = 8;
    lopputeks.rajausnelio.korkeus = 98;
    lopputeks.ruudulla = 4;
    erikoisefekti = true;
    efektiptr = &teksliike;

    liplap.x = 8;
    liplap.y = 150;
    liplap.toiminta = true;
    liplap.toimintakatto = 10;
    liplap.toimintaptr = &liplapfunktio;
    liplap.ruudulla = 4;

    pilvi2.x = 126;
    pilvi2.y = 14;
    pilvi2.suunta = 6;
    pilvi2.vauhti = 20;
    pilvi2.ruudulla = 4;
    pilvi2.rajattu = false;

    aalto.toiminta = true;
    aalto.toimintakatto = 58;
    aalto.toimintaptr = &aaltofunktio;

    kasvi1.kaksivarinen = true;
    kasvi1.x = 92;
    kasvi1.y = 147;
    kasvi1.ruudulla = 2;
    kasvi1.framehidastus = 4;
    kasvi1.framekierto.push_back(0);
    kasvi1.framekierto.push_back(1);
    kasvi1.framekierto.push_back(2);
    kasvi1.framekierto.push_back(3);
    kasvi1.framekierto.push_back(2);
    kasvi1.framekierto.push_back(1);   
    kasvi1.framekierto.push_back(0);
    kasvi1.framekierto.push_back(99);
    kasvi1.framekierto.push_back(5);

    kasvi2.kaksivarinen = true;
    kasvi2.x = 72;
    kasvi2.y = 157;
    kasvi2.ruudulla = 2;
    kasvi2.framehidastus = 4;
    kasvi2.framekierto.push_back(0);
    kasvi2.framekierto.push_back(1);
    kasvi2.framekierto.push_back(2);
    kasvi2.framekierto.push_back(3);
    kasvi2.framekierto.push_back(2);
    kasvi2.framekierto.push_back(1);   
    kasvi2.framekierto.push_back(0);
    kasvi2.framekierto.push_back(99);
    kasvi2.framekierto.push_back(5);

    taustakuva = true;
    taustakuva_ptr = &maisema_bm;
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 1502) {
    lintu1.x = 0;
    lintu1.y = 0;
    lintu1.ruudulla = 4;
    lintu1.framekierto.push_back(0);
    lintu1.framekierto.push_back(1);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(3);
    lintu1.framekierto.push_back(2);
    lintu1.framekierto.push_back(1);   
    lintu1.framekierto.push_back(0);
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toimintaptr = &linnunrata;
    t_ajastin = 100;
  }
  else if(tarinanvaihe == 1504) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 1;
    t_ajastin = 200;
  }
  else if(tarinanvaihe == 1506) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 2;
    t_ajastin = 200;
  }
  else if(tarinanvaihe == 1508) {
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toim_arg = 2;
    t_ajastin = 170;
  }

  else if(tarinanvaihe == 1510) {
    lintu1.x = 0;
    lintu1.y = 0;
    lintu1.ruudulla = 4;
    lintu1.toiminta = true;
    lintu1.toimintakatto = 100;
    lintu1.toimintaptr = &linnunrata;
    t_ajastin = 80;
  }
  else if(tarinanvaihe == 1518) {
    lopeta_musa(teema_h);
    taustakuva = false;
    kaikki_pois_ruudulta();
    tyhjenna_vfb();
    tyhjenna_ruutu();
    t_ajastin = 20;
  }

  else if(tarinanvaihe == 2000) {
    KAIKKI_POIS;
    lopetus = true;
  }
  else osuma = false;

  //tfloppu
  return osuma;
}

void sammuttelu() {

  KAIKKI_POIS;

  alkuteks.poista_bittikartta();
  lopputeks.poista_bittikartta();
  morteks.poista_bittikartta();
  maisteks.poista_bittikartta();
  teksvill.poista_bittikartta();
  textparc.poista_bittikartta();
  textperi.poista_bittikartta();
  czteksti.poista_bittikartta();
  error.poista_bittikartta();
  eeg.poista_bittikartta();
  eegpeite.poista_bittikartta();
  eegtaulu.poista_bittikartta();
  glogo.poista_bittikartta();
  auto1.poista_bittikartta();
  ambu2.poista_bittikartta();
  amovi.poista_bittikartta();
  paaylos.poista_bittikartta();
  kasi1.poista_bittikartta();
  kasi2.poista_bittikartta();
  kasi3.poista_bittikartta();
  ilme.poista_bittikartta();
  protais.poista_bittikartta();
  prota4.poista_bittikartta();
  hiseina.poista_bittikartta();
  hikansi.poista_bittikartta();
  hilat.poista_bittikartta();
  pilvi1.poista_bittikartta();
  pilvi2.poista_bittikartta();
  pilvi3.poista_bittikartta();
  ovi1.poista_bittikartta();
  ovi2.poista_bittikartta();
  profis.poista_bittikartta();
  aalto.poista_bittikartta();
  liplap.poista_bittikartta();
  tvmies.poista_bittikartta();
  puuosa.poista_bittikartta();
  puita.poista_bittikartta();
  juna.poista_bittikartta();
  cz_poyta.poista_bittikartta();
  bovi1.poista_bittikartta();
  bovi2.poista_bittikartta();
  potkula.poista_bittikartta();
  pluga.poista_bittikartta();
  plugb.poista_bittikartta();
  plugc.poista_bittikartta();
  osa.poista_bittikartta();
  lintu2.poista_bittikartta();
  ascii1.poista_bittikartta();
  ascii2.poista_bittikartta();
  ascii3.poista_bittikartta();
  ascii4.poista_bittikartta();
  lintu1.poista_bittikartta();
  plintu.poista_bittikartta();
  keinu.poista_bittikartta();
  drone.poista_bittikartta();
  nokka.poista_bittikartta();
  kasvi1.poista_bittikartta(); //kasvi2:ssa on sama bittikartta
  droidi.poista_bittikartta();
  prota1.poista_bittikartta();
  prota2.poista_bittikartta();
  prota3.poista_bittikartta();
  prof.poista_bittikartta();
  avustaja.poista_bittikartta();
  kulkija1.poista_bittikartta();
  kulkija2.poista_bittikartta();
  kulkija3.poista_bittikartta();
  kulkija4.poista_bittikartta();
  kulkija5.poista_bittikartta();
  kulkija6.poista_bittikartta();
  koira.poista_bittikartta();
  ambuh.poista_bittikartta();
  liovi.poista_bittikartta();
  hisovi.poista_bittikartta();
  thovi.poista_bittikartta();
  aivobzz.poista_bittikartta();
  ambu3.poista_bittikartta();
  ambu4.poista_bittikartta();
  
  MIDASfreeModule(teema);
  MIDASfreeModule(baarimusa);
  MIDASfreeModule(ambu);
  MIDASfreeModule(parcf);
  MIDASfreeModule(ranta);
  MIDASfreeModule(perif);
  MIDASfreeModule(instf);
  MIDASfreeModule(seko);

  MIDASclose();

  //Takaisin DOSsin oletusnäyttötilaan
  asm("mov $0x0, %ax");
  asm("mov $0x3, %ax");
  asm("int $0x10");
  
}

int main(int argc, char** argv) {

  int framen_kesto = CLOCKS_PER_SEC/24;

  MIDASstartup();
  MIDASinit();
  
  auto_s = MIDASloadWaveSample((char*)"auto.wav", 0);
  ovi1_s = MIDASloadWaveSample((char*)"ovi1.wav", 0);
  ovi2_s = MIDASloadWaveSample((char*)"ovi2.wav", 0);
  tvkohina_s = MIDASloadWaveSample((char*)"tvkohina.wav", 0);
  radio_s = MIDASloadWaveSample((char*)"radio.wav", 0);
  propuhe1_s = MIDASloadWaveSample((char*)"propuhe1.wav", 0);
  paapuhe1_s = MIDASloadWaveSample((char*)"paapuhe1.wav", 0);
  propuhe2_s = MIDASloadWaveSample((char*)"propuhe2.wav", 0);
  paapuhe2_s = MIDASloadWaveSample((char*)"paapuhe2.wav", 0);
  ankpuhe1_s = MIDASloadWaveSample((char*)"intruder.wav", 0);
  ankpuhe2_s = MIDASloadWaveSample((char*)"escapes.wav", 0);
  liuovi_s = MIDASloadWaveSample((char*)"liuovi.wav", 0);
  kaup_s = MIDASloadWaveSample((char*)"kaup.wav", 0);
  kaytava_s = MIDASloadWaveSample((char*)"kaytava.wav", 0);
  hissi_s = MIDASloadWaveSample((char*)"hissi.wav", 0);
  hisovi_s = MIDASloadWaveSample((char*)"hisovi.wav", 0);
  erovi_s = MIDASloadWaveSample((char*)"erovi.wav", 0);
  czteksti_s = MIDASloadWaveSample((char*)"czteksti.wav", 0);
  cz_s = MIDASloadWaveSample((char*)"cz.wav", 0);
  bzz_s = MIDASloadWaveSample((char*)"bzz.wav", 0);
  laser_s = MIDASloadWaveSample((char*)"laser.wav", 0);
  lintu1_s = MIDASloadWaveSample((char*)"lintu1.wav", 0);
  lintu2_s = MIDASloadWaveSample((char*)"lintu2.wav", 0);
  lintu3_s = MIDASloadWaveSample((char*)"lintu3.wav", 0);
  lyhyt_s = MIDASloadWaveSample((char*)"lyhyt.wav", 0);
  pitka_s = MIDASloadWaveSample((char*)"pitka.wav", 0);
  lintu4_s = MIDASloadWaveSample((char*)"lintu4.wav", 0);
  lintu5_s = MIDASloadWaveSample((char*)"lintu5.wav", 0);
  kaatuu_s = MIDASloadWaveSample((char*)"kaatuu.wav", 0);
  g_aani_s = MIDASloadWaveSample((char*)"g-aani.wav", 0);
  error_s = MIDASloadWaveSample((char*)"error.wav", 0);
  uli1_s = MIDASloadWaveSample((char*)"uli1.wav", 0);
  g_aani2_s = MIDASloadWaveSample((char*)"g-aani2.wav", 0);
  uli2_s = MIDASloadWaveSample((char*)"uli2.wav", 0);
  syspiip_s = MIDASloadWaveSample((char*)"sysbeep.wav", 0);

  MIDASopenChannels(5);
  MIDASallocAutoEffectChannels(4);

  teema = MIDASloadModule((char*)"teema.it");
  baarimusa = MIDASloadModule((char*)"baari.it");
  ambu = MIDASloadModule((char*)"ambu.it");
  parcf = MIDASloadModule((char*)"parc.it");
  ranta = MIDASloadModule((char*)"ranta.it");
  perif = MIDASloadModule((char*)"peri.it");
  instf = MIDASloadModule((char*)"inst.it");
  seko = MIDASloadModule((char*)"seko.it");

  maisema_bm = avaa_kuva(maisema_bm, "maisema.pbk"); 
  huone_bm = avaa_kuva(huone_bm, "huone.pbk");
  kotitalo_bm = avaa_kuva(huone_bm, "kotitalo.pbk");
  metsikko_bm = avaa_kuva(huone_bm, "metsikko.pbk");
  masto_bm = avaa_kuva(masto_bm, "masto.pbk");
  kaupunki1_bm = avaa_kuva(kaupunki1_bm, "kaup1.pbk");
  kaupunki2_bm = avaa_kuva(kaupunki2_bm, "kaup2.pbk");
  kaupunki3_bm = avaa_kuva(kaupunki3_bm, "kaup3.pbk");
  puisto_bm = avaa_kuva(puisto_bm, "puisto.pbk");
  puisto2_bm = avaa_kuva(puisto2_bm, "puisto2.pbk");
  ranta_bm = avaa_kuva(ranta_bm, "ranta.pbk");
  peri1_bm = avaa_kuva(peri1_bm, "peri1.pbk");
  peri2_bm = avaa_kuva(peri2_bm, "peri2.pbk");
  peri3_bm = avaa_kuva(peri3_bm, "peri3.pbk");
  perig_bm = avaa_kuva(perig_bm, "perig.pbk");
  baari_bm = avaa_kuva(baari_bm, "baari.pbk");
  insttalo_bm = avaa_kuva(insttalo_bm, "insttalo.pbk");
  instkylt_bm = avaa_kuva(instkylt_bm, "instkylt.pbk");
  kaytava_bm = avaa_kuva(kaytava_bm, "kaytava.pbk");
  hissi_bm = avaa_kuva(hissi_bm, "hissi.pbk");
  ylakerta_bm = avaa_kuva(ylakerta_bm, "ylakerta.pbk");
  cz_bm = avaa_kuva(cz_bm, "cz.pbk");
  tuolipaa_bm = avaa_kuva(tuolipaa_bm, "tuolipaa.pbk");
  isolintu_bm = avaa_kuva(isolintu_bm, "isolintu.pbk");

  aivot_bm = avaa_kuva(aivot_bm, "aivot.pbk");

  aivobzz_bm = avaa_kuva(aivobzz_bm, "aivobzz.pbk");
  aivobzz.kuva = &aivobzz_bm;
  aivobzz.arkki_w = 16;
  aivobzz.arkki_h = 16;
  aivobzz2_bm = avaa_kuva(aivobzz2_bm, "aivobzz2.pbk");
  aivobzz3_bm = avaa_kuva(aivobzz3_bm, "aivobzz3.pbk");

  auto1_bm = avaa_kuva(auto1_bm, "auto1.pbk");
  auto1.kuva = &auto1_bm;
  auto1.kaksivarinen = true;

  ambu2_bm = avaa_kuva(ambu2_bm, "ambu2.pbk");
  ambu2.kuva = &ambu2_bm;
  ambu2.kaksivarinen = true;
  
  amovi_bm = avaa_kuva(amovi_bm, "amovi.pbk");
  amovi.kuva = &amovi_bm;
  amovi.kaksivarinen = true;

  paauli_bm = avaa_kuva(paauli_bm, "paauli.pbk");
  
  paaylos_bm = avaa_kuva(paaylos_bm, "paaylos.pbk");
  paaylos.kuva = &paaylos_bm;
  paaylos.kaksivarinen = true;
  
  kasi1_bm = avaa_kuva(kasi1_bm, "kasi1.pbk");
  kasi1.kuva = &kasi1_bm;
  kasi1.kaksivarinen = true;
  kasi2_bm = avaa_kuva(kasi2_bm, "kasi2.pbk");
  kasi2.kuva = &kasi2_bm;
  kasi2.kaksivarinen = true;
  kasi3_bm = avaa_kuva(kasi3_bm, "kasi3.pbk");
  kasi3.kuva = &kasi3_bm;
  kasi3.kaksivarinen = true;
  ilme_bm = avaa_kuva(ilme_bm, "ilme.pbk");
  ilme.kuva = &ilme_bm;
  ilme.kaksivarinen = true;
  
  protais_bm = avaa_kuva(protais_bm, "protais.pbk");
  protais.kuva = &protais_bm;
  protais.kaksivarinen = true;

  prota4_bm = avaa_kuva(prota4_bm, "prota4.pbk");
  prota4.kuva = &prota4_bm;
  prota4.kaksivarinen = true;
  
  hiseina_bm = avaa_kuva(hiseina_bm, "hiseina.pbk");
  hiseina.kuva = &hiseina_bm;
  hiseina.kaksivarinen = true;

  hikansi_bm = avaa_kuva(hikansi_bm, "hikansi.pbk");
  hikansi.kuva = &hikansi_bm;
  hikansi.kaksivarinen = true;

  hilat_bm = avaa_kuva(hilat_bm, "hilat.pbk");
  hilat.kuva = &hilat_bm;
  hilat.kaksivarinen = true;
  
  pilvi1_bm = avaa_kuva(pilvi1_bm, "pilvi1.pbk");
  pilvi1.kuva = &pilvi1_bm;

  pilvi2_bm = avaa_kuva(pilvi2_bm, "pilvi2.pbk");
  pilvi2.kuva = &pilvi2_bm;

  pilvi3_bm = avaa_kuva(pilvi3_bm, "pilvi3.pbk");
  pilvi3.kuva = &pilvi3_bm;

  ovi1_bm = avaa_kuva(ovi1_bm, "ovi1.pbk");
  ovi1.kuva = &ovi1_bm;

  ovi2_bm = avaa_kuva(ovi2_bm, "ovi2.pbk");
  ovi2.kuva = &ovi2_bm;
  ovi2.kaksivarinen = true;

  profis_bm = avaa_kuva(profis_bm, "profis.pbk");
  profis.kuva = &profis_bm;
  
  alkuteks_bm = avaa_kuva(alkuteks_bm, "alkuteks.pbk");
  alkuteks.kuva = &alkuteks_bm;

  lopputeks_bm = avaa_kuva(lopputeks_bm, "loppteks.pbk");
  lopputeks.kuva = &lopputeks_bm;

  eof_bm = avaa_kuva(eof_bm, "eof.pbk");
  
  morteks_bm = avaa_kuva(morteks_bm, "morteks.pbk");
  morteks.kuva = &morteks_bm;

  maisteks_bm = avaa_kuva(maisteks_bm, "maisteks.pbk");
  maisteks.kuva = &maisteks_bm;

  aveteks_bm = avaa_kuva(aveteks_bm, "aveteks.pbk");

  teksvill_bm = avaa_kuva(teksvill_bm, "textvill.pbk");
  teksvill.kuva = &teksvill_bm;

  textparc_bm = avaa_kuva(textparc_bm, "textparc.pbk");
  textparc.kuva = &textparc_bm;

  textperi_bm = avaa_kuva(textperi_bm, "textperi.pbk");
  textperi.kuva = &textperi_bm;

  texdrama_bm = avaa_kuva(texdrama_bm, "texdrama.pbk");

  czteksti_bm = avaa_kuva(czteksti_bm, "czteksti.pbk");
  czteksti.kuva = &czteksti_bm;

  textmitt_bm = avaa_kuva(textmitt_bm, "textmitt.pbk");
  
  defai_bm = avaa_kuva(defai_bm, "defai.pbk");
  fehler_bm = avaa_kuva(fehler_bm, "fehler.pbk");
  
  error_bm = avaa_kuva(error_bm, "error.pbk");
  error.kuva = &error_bm;
  ambu_bm = avaa_kuva(ambu_bm, "ambu.pbk");
  
  eeg_bm = avaa_kuva(eeg_bm, "eeg.pbk");
  eeg.kuva = &eeg_bm;
  eegpeite_bm = avaa_kuva(eegpeite_bm, "eegpeite.pbk");
  eegpeite.kuva = &eegpeite_bm;
  eegpeite.kaksivarinen = true;
  eegtaulu_bm = avaa_kuva(eegtaulu_bm, "eegtaulu.pbk");
  eegtaulu.kuva = &eegtaulu_bm;

  ascii1_bm = avaa_kuva(ascii1_bm, "ascii1.pbk");
  ascii1.kuva = &ascii1_bm;
  ascii1.kaksivarinen = true;
  ascii2_bm = avaa_kuva(ascii2_bm, "ascii2.pbk");
  ascii2.kuva = &ascii2_bm;
  ascii2.kaksivarinen = true;
  ascii3_bm = avaa_kuva(ascii3_bm, "ascii3.pbk");
  ascii3.kuva = &ascii3_bm;
  ascii3.kaksivarinen = true;
  ascii4_bm = avaa_kuva(ascii4_bm, "ascii4.pbk");
  ascii4.kuva = &ascii4_bm;
  ascii4.kaksivarinen = true;

  pommit_bm = avaa_kuva(pommit_bm, "pommit.pbk");
  kaatuu_bm = avaa_kuva(kaatuu_bm, "kaatuu.pbk");

  autotie_bm = avaa_kuva(autotie_bm, "autotie.pbk");

  mittari_bm = avaa_kuva(mittari_bm, "mittari.pbk"); 
  sydan_bm = avaa_kuva(sydan_bm, "sydan.pbk");
  
  glogo_bm = avaa_kuva(glogo_bm, "glogo.pbk");
  glogo.kuva = &glogo_bm;
  
  aalto_bm = avaa_kuva(aalto_bm, "aalto.pbk");
  aalto.kuva = &aalto_bm;

  liplap_bm = avaa_kuva(liplap_bm, "liplap.pbk");
  liplap.kuva = &liplap_bm;

  puuosa_bm = avaa_kuva(puuosa_bm, "puuosa.pbk");
  puuosa.kuva = &puuosa_bm;
  puita_bm = avaa_kuva(puita_bm, "puita.pbk");
  puita.kuva = &puita_bm;
  puita.kaksivarinen = true;

  juna_bm = avaa_kuva(juna_bm, "juna.pbk");
  juna.kuva = &juna_bm;
  juna.kaksivarinen = true;

  cz_poyta_bm = avaa_kuva(cz_poyta_bm, "cz-poyta.pbk");
  cz_poyta.kuva = &cz_poyta_bm;
  cz_poyta.kaksivarinen = true;
  
  bovi1_bm = avaa_kuva(bovi1_bm, "bovi1.pbk");
  bovi1.kuva = &bovi1_bm;
  bovi1.kaksivarinen = true;
  bovi2_bm = avaa_kuva(bovi2_bm, "bovi2.pbk");
  bovi2.kuva = &bovi2_bm;
  bovi2.kaksivarinen = true;

  potkula_bm = avaa_kuva(potkula_bm, "potkula.pbk");
  potkula.kuva = &potkula_bm;
  potkula.kaksivarinen = true;

  lintu2_bm = avaa_kuva(lintu2_bm, "lintu2.pbk");
  lintu2.kuva = &lintu2_bm;
  
  pluga_bm = avaa_kuva(pluga_bm, "plug_a.pbk");
  pluga.kuva = &pluga_bm;
  plugb_bm = avaa_kuva(plugb_bm, "plug_b.pbk");
  plugb.kuva = &plugb_bm;
  plugc_bm = avaa_kuva(plugc_bm, "plug_c.pbk");
  plugc.kuva = &plugc_bm;
  plugc.kaksivarinen = true;
  osa_bm = avaa_kuva(osa_bm, "osa.pbk");
  osa.kuva = &osa_bm;
  
  lintu1_bm = avaa_kuva(lintu1_bm, "lintu1.pbk");
  lintu1.kuva = &lintu1_bm;
  lintu1.arkki_w = 24;
  lintu1.arkki_h = 7;

  plintu_bm = avaa_kuva(plintu_bm, "plintu.pbk");
  plintu.kuva = &plintu_bm;
  plintu.arkki_w = 28;
  plintu.arkki_h = 19;
  plintu.kaksivarinen = true;

  keinu_bm = avaa_kuva(keinu_bm, "keinu.pbk");
  keinu.kuva = &keinu_bm;
  keinu.arkki_w = 52;
  keinu.arkki_h = 45;
  keinu.kaksivarinen = true;
  
  drone_bm = avaa_kuva(drone_bm, "drone.pbk");
  drone.kuva = &drone_bm;
  drone.arkki_w = 24;
  drone.arkki_h = 19;
  drone.kaksivarinen = true;
  
  nokka_bm = avaa_kuva(nokka_bm, "nokka.pbk");
  nokka.kuva = &nokka_bm;
  nokka.arkki_w = 100;
  nokka.arkki_h = 66;
  
  droidi_bm = avaa_kuva(droidi_bm, "droidi.pbk");
  droidi.kuva = &droidi_bm;
  droidi.arkki_w = 52;
  droidi.arkki_h = 32;
  droidi.kaksivarinen = true;
  
  kasvi1_bm = avaa_kuva(kasvi1_bm, "osman.pbk");
  kasvi1.kuva = &kasvi1_bm;
  kasvi1.arkki_w = 40;
  kasvi1.arkki_h = 50;
  kasvi2.kuva = &kasvi1_bm;
  kasvi2.arkki_w = 40;
  kasvi2.arkki_h = 50;

  prota1_bm = avaa_kuva(prota1_bm, "prota1.pbk");
  prota1.kuva = &prota1_bm;
  prota1.arkki_w = 24;
  prota1.arkki_h = 40;
  prota1.kaksivarinen = true;
  prota1.kframet[0] = 6;
  prota1.kframet[1] = 6;
  prota1.kframet[2] = 0;
  prota1.kframet[3] = 6;
  prota1.kframet[4] = 12;
  prota1.kframet[5] = 8;
  prota1.kframet[6] = 12;
  prota1.kframet[7] = 8;

  prota2_bm = avaa_kuva(prota2_bm, "prota2.pbk");
  prota2.kuva = &prota2_bm;
  prota2.arkki_w = 20;
  prota2.arkki_h = 40;
  prota2.kaksivarinen = true;

  prota3_bm = avaa_kuva(prota3_bm, "prota3.pbk");
  prota3.kuva = &prota3_bm;
  prota3.arkki_w = 36;
  prota3.arkki_h = 39;
  prota3.kaksivarinen = true;
  
  prof_bm = avaa_kuva(prof_bm, "prof.pbk");
  prof.kuva = &prof_bm;
  prof.arkki_w = 24;
  prof.arkki_h = 40;
  prof.kaksivarinen = true;
  prof.kframet[0] = 6;
  prof.kframet[1] = 6;
  prof.kframet[2] = 1;
  prof.kframet[3] = 5;
  prof.kframet[4] = 12;
  prof.kframet[5] = 8;
  prof.kframet[6] = 12;
  prof.kframet[7] = 8;

  avustaja_bm = avaa_kuva(avustaja_bm, "avustaja.pbk");
  avustaja.kuva = &avustaja_bm;
  avustaja.arkki_w = 24;
  avustaja.arkki_h = 40;
  avustaja.kaksivarinen = true;
  avustaja.kframet[4] = 0;
  avustaja.kframet[5] = 8;
  
  kulkija1_bm = avaa_kuva(kulkija1_bm, "kulkija1.pbk");
  kulkija1.kuva = &kulkija1_bm;
  kulkija1.arkki_w = 20;
  kulkija1.arkki_h = 42;
  kulkija1.kaksivarinen = true;
  kulkija1.kframet[4] = 0;
  kulkija1.kframet[5] = 8;
  kulkija1.kframet[6] = 0;
  kulkija1.kframet[7] = 8;

  kulkija2_bm = avaa_kuva(kulkija2_bm, "kulkija2.pbk");
  kulkija2.kuva = &kulkija2_bm;
  kulkija2.arkki_w = 20;
  kulkija2.arkki_h = 40;
  kulkija2.kaksivarinen = true;
  kulkija2.kframet[4] = 0;
  kulkija2.kframet[5] = 8;
  kulkija2.kframet[6] = 0;
  kulkija2.kframet[7] = 8;

  kulkija3_bm = avaa_kuva(kulkija3_bm, "kulkija3.pbk");
  kulkija3.kuva = &kulkija3_bm;
  kulkija3.arkki_w = 48;
  kulkija3.arkki_h = 42;
  kulkija3.kaksivarinen = true;
  kulkija3.kframet[4] = 0;
  kulkija3.kframet[5] = 4;
  kulkija3.kframet[6] = 0;
  kulkija3.kframet[7] = 4;

  kulkija4_bm = avaa_kuva(kulkija4_bm, "kulkija4.pbk");
  kulkija4.kuva = &kulkija4_bm;
  kulkija4.arkki_w = 20;
  kulkija4.arkki_h = 42;
  kulkija4.kaksivarinen = true;
  kulkija4.kframet[4] = 0;
  kulkija4.kframet[5] = 8;
  kulkija4.kframet[6] = 0;
  kulkija4.kframet[7] = 8;

  kulkija5_bm = avaa_kuva(kulkija5_bm, "kulkija5.pbk");
  kulkija5.kuva = &kulkija5_bm;
  kulkija5.arkki_w = 20;
  kulkija5.arkki_h = 42;
  kulkija5.kaksivarinen = true;
  kulkija5.kframet[4] = 0;
  kulkija5.kframet[5] = 8;
  kulkija5.kframet[6] = 0;
  kulkija5.kframet[7] = 8;

  kulkija6_bm = avaa_kuva(kulkija6_bm, "kulkija6.pbk");
  kulkija6.kuva = &kulkija6_bm;
  kulkija6.arkki_w = 20;
  kulkija6.arkki_h = 39;
  kulkija6.kaksivarinen = true;
  kulkija6.kframet[4] = 0;
  kulkija6.kframet[5] = 8;

  koira_bm = avaa_kuva(koira_bm, "koira.pbk");
  koira.kuva = &koira_bm;
  koira.arkki_w = 32;
  koira.arkki_h = 20;
  koira.kframet[4] = 0;
  koira.kframet[5] = 4;

  ambuh_bm = avaa_kuva(ambuh_bm, "ambuh.pbk");
  ambuh.kuva = &ambuh_bm;
  ambuh.arkki_w = 56;
  ambuh.arkki_h = 43;
  ambuh.kaksivarinen = true;
  ambuh.kframet[0] = 0;
  ambuh.kframet[1] = 4;
  ambuh.kframet[2] = 0;
  ambuh.kframet[3] = 4;
  ambuh.kframet[4] = 0;
  ambuh.kframet[5] = 4;
  ambuh.kframet[6] = 0;
  ambuh.kframet[7] = 4;

  tvmies_bm = avaa_kuva(tvmies_bm, "tvmies.pbk");
  tvmies.kuva = &tvmies_bm;

  liovi_bm = avaa_kuva(liovi_bm, "liovi.pbk");
  liovi.kuva = &liovi_bm;
  liovi.arkki_w = 30;
  liovi.arkki_h = 45;
  liovi.kaksivarinen = true;

  hisovi_bm = avaa_kuva(hisovi_bm, "hisovi.pbk");
  hisovi.kuva = &hisovi_bm;
  hisovi.arkki_w = 20;
  hisovi.arkki_h = 68;
  hisovi.kaksivarinen = true;

  thovi_bm = avaa_kuva(thovi_bm, "thovi.pbk");
  thovi.kuva = &thovi_bm;
  thovi.arkki_w = 32;
  thovi.arkki_h = 48;
  thovi.kaksivarinen = true;

  ambu3_bm = avaa_kuva(ambu3_bm, "ambu3.pbk");
  ambu3.kuva = &ambu3_bm;
  ambu3.arkki_w = 52;
  ambu3.arkki_h = 63;
  ambu3.kaksivarinen = true;

  ambu4_bm = avaa_kuva(ambu4_bm, "ambu4.pbk");
  ambu4.kuva = &ambu4_bm;
  ambu4.arkki_w = 24;
  ambu4.arkki_h = 27;
  ambu4.kaksivarinen = true;
  
  asm("mov $0x0, %al");
  asm("mov $0x0, %ah");
  asm("mov $0x0, %bx");
  
  asm("mov $0x4, %al");  //mode 04 = CGA 320x200
  asm("int $0x10");

  asm("mov $0xb, %ah");
  asm("mov $0x10, %bx"); //korkea intensiteetti
  asm("int $0x10");
  
  asm("mov $0xb, %ah");  
  asm("mov $0x100, %bx"); //paletti: puna-vihreä-ruskea
  asm("int $0x10");

  int ajastin1;
  double ajastin2;

  //PÄÄLOOPPI
  while(1) {

    ajastin1 = clock();

    if(lopetus) break;

    if(t_ajastin) {
      t_ajastin--;
      if(t_ajastin == 0) tkesk = true;
    }
    if(tkesk) {
      tkesk = false;
      do tarinanvaihe++; while (!tarinafunktio());
    }

    if(taustakuva) piirrakuva(taustakuva_ptr, 0, 0, false);

    for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
      if((*ev_iter)->ruudulla == 0 and (*ev_iter)->toiminta) (**ev_iter).esinepiirto();
    }
    for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
      if((*ev_iter)->ruudulla == 4) (**ev_iter).esinepiirto();
    }
    for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
      if((*h_iter)->ruudulla == 4) (**h_iter).hahmopiirto();
    }
    for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) { 
     if((*ev_iter)->ruudulla == 3) (**ev_iter).esinepiirto();
    }
    for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
      if((*h_iter)->ruudulla == 3) (**h_iter).hahmopiirto();
    }
    for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
      if((*ev_iter)->ruudulla == 2) (**ev_iter).esinepiirto();
    }
    for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
      if((*h_iter)->ruudulla == 2) (**h_iter).hahmopiirto();
    }
    for(vector<esineluokka*>::iterator ev_iter = esinevec.begin(); ev_iter != esinevec.end(); ++ev_iter) {
      if((*ev_iter)->ruudulla == 1) (**ev_iter).esinepiirto();
    }
    for(vector<hahmoluokka*>::iterator h_iter = hahmovec.begin(); h_iter != hahmovec.end(); ++h_iter) {
      if((*h_iter)->ruudulla == 1) (**h_iter).hahmopiirto();
    }
    
    if(aaniloop_kerrat > 0) {
      aaniloop_kountteri--;
      if(aaniloop_kountteri == 0) {
	MIDASplaySample(*aaniloop_sample, MIDAS_CHANNEL_AUTO, 0, 11025, 63, 1);
	aaniloop_kerrat--;
	if(aaniloop_kerrat > 0) {
	  aaniloop_kountteri = aaniloop_kesto;
	}
      }
    }
    if(erikoisefekti) {
      efektiptr(t_ajastin);
      if(efektikountteri) efektikountteri--;
    }
    if(erikoisefekti2) efektiptr2(t_ajastin);

    piirraruutu();
    
    while(clock()-ajastin1 < framen_kesto) asm("hlt");
    
  }
  sammuttelu();
  return 0;
}
